\let\oldsubsection=\subsection
\renewcommand{\subsection}{%
  \filbreak
  \oldsubsection
}

\newcommand{\kwargs}{{\it keywords}}
\newcommand{\var}[1]{{\it #1}}
\newcommand{\kw}[3]{
	\null\hspace{3em}
	\var{#1}
	(#2)
	\newline
	\null\hspace{5em}
	#3
}

\newcommand{\kwtabb}[0]{
	\small
	\begin{tabular}{|l|l|r|l|l|}
	\hline
	Keyword         & Type           & Default       & Unit           & Description\\
	\hline \hline
}
\newcommand{\kwtabe}[0]{
	\hline
	\end{tabular}
	\normalsize
}

\newcommand{\commonpsdkwargs}[0]{%
{\tt depth }         & FLT    & $7          $ & & Refinement depth of the tree.\\
{\tt nexp  }         & FLT    & $2          $ & & $\log_2$(sample points / dimension).\\
{\tt weight}         & FLT    & $1.0        $ & & Weight of the distribution.\\
{\tt limits}         & FLT[4] & $[-1,-1,1,1]$ & & bounding box limits $[q_{\min{}},p_{\min{}},q_{\max{}},p_{\max{}}]$.\\
{\tt interpolation } & FLT    & $2          $ & & Interpolation method (nearest, linear, cubic).\\
{\tt topology }      & FLT    & $0          $ & & Topology ($\R^2$, $S^1\times\R^1$, $\R^1\times S^1$, and $S^2$).
}

\newcommand{\refentry}[7]{
\begin{samepage}
\subsection*{#1}
\addcontentsline{toc}{subsection}{#1}
\label{#2}
\def\temp{#3}\ifx\temp\empty{}\else
\subsubsection*{Synopsis}
#3
\fi
\def\temp{#4}\ifx\temp\empty{}\else
\subsubsection*{Description}
#4
\fi
\def\temp{#5}\ifx\temp\empty{}\else
\subsubsection*{Return Value}
#5
\fi
\def\temp{#6}\ifx\temp\empty
\else
\subsubsection*{Keywords}
\kwtabb{}%
#6
\kwtabe{}
\\
\fi
\def\temp{#7}\ifx\temp\empty{}\else
\subsubsection*{Example}%
#7%
\fi
\end{samepage}
%\smallskip
%\hrule
\vfill
}
