/*
* libselav - a framework for semi-lagrangian simulation of sparse densities
* Copyright (C) 2020-2022  Philipp Amstutz (DESY)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/


#ifndef ACCPHYS_H
#define ACCPHYS_H
#include "stddef.h"
#include "accphys.h"
void transfer4d(double* R1, const double* R0, double l, double fangle, double k0, double k1);
double chicanecoef(int n, double angle, double lB, double lD, char type=0);
double average(double z0, double z1, const double* zp, const double* yp, size_t n);
#endif
