/*
* libselav - a framework for semi-lagrangian simulation of sparse densities
* Copyright (C) 2020-2022  Philipp Amstutz (DESY)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SLV_DEBUG_H
#define SLV_DEBUG_H

#include <iostream>

#if DEBUG_LVL >= 1
	#define DBG_ARRAY(arr) for(auto n : arr) std::cout << n << " "; std::cout << std::endl
	#define DBG_CNSTR_MSG_1 std::cout << "\033[30;43mCNSTR\033[0m \033[32m" << __PRETTY_FUNCTION__ << "\033[0m\n"
	#define DBG_MSG_1(msg) std::cout  << "\033[37;44m MSG \033[0m \033[37;1m" << msg << "\033[0m\n"
#else
	#define DBG_ARRAY(arr)
	#define DBG_CNSTR_MSG_1
	#define DBG_MSG_1(msg)
#endif

#if DEBUG_LVL >= 2
	#define DBG_CNSTR_MSG_2 std::cout << "\033[30;43mCNSTR\033[0m \033[32m" << __PRETTY_FUNCTION__ << "\033[0m\n"
	#define DBG_MSG_2(msg) std::cout  << "\033[37;44m MSG \033[0m \033[37;1m" << msg << "\033[0m\n"
#else
	#define DBG_CNSTR_MSG_2
	#define DBG_MSG_2(msg)
#endif

#if DEBUG_LVL >= 3
	#define DBG_CNSTR_MSG_3 std::cout << "\033[30;43mCNSTR\033[0m \033[32m" << __PRETTY_FUNCTION__ << "\033[0m\n"
	#define DBG_DESTR_MSG_3 std::cout << "\033[30;41mDESTR\033[0m \033[32m" << __PRETTY_FUNCTION__ << "\033[0m\n"
	#define DBG_MSG_3(msg) std::cout  << "\033[37;44m MSG \033[0m \033[37;1m" << msg << "\033[0m\n"
#else
	#define DBG_CNSTR_MSG_3
	#define DBG_DESTR_MSG_3
	#define DBG_MSG_3(msg)
#endif


#endif
