/*
* libselav - a framework for semi-lagrangian simulation of sparse densities
* Copyright (C) 2020-2022  Philipp Amstutz (DESY)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SLV_FUNCTIONS_H
#define SLV_FUNCTIONS_H

void disk2D(const double* in, double* out, int N, const void* arg);
void smiley2D(const double* in, double* out, int N, const void* arg);
struct gauss2D_args {double sig_q; double sig_p; double correlation; double cutoff;};
void gauss2D(const double* in, double* out, int N, const void* arg);
void rectangle(const double* in, double* out, int N, const void* arg);
struct monomial_args {int dim; const double* exps;};
void monomial(const double* val, const double* in, double* out, int N, const void* args_);
void bump(const double* in, double* out, int N, const void* args);

#endif
