/*
* libselav - a framework for semi-lagrangian simulation of sparse densities
* Copyright (C) 2020-2022  Philipp Amstutz (DESY)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SLV_POISSON1D_H
#define SLV_POISSON1D_H

#include <complex.h>
#include <cstddef>

struct solve_poisson1d_args {
	double T; // ``Sampling time''
	int npad; // Padding factor
};

void solve_poisson1d(const double* data, double* out, size_t npts, const void* args, char* prefix = NULL);

#endif
