/*
* libselav - a framework for semi-lagrangian simulation of sparse densities
* Copyright (C) 2020-2022  Philipp Amstutz (DESY)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SLV_PSDFROMMOMENTS_H
#define SLV_PSDFROMMOMENTS_H

struct psd_frommoments_args {
	double* moments = NULL; // Pointers to arrays of moments
	double limits[2];
	int nslices; // Number of data points
	int order=4;
	double cutoff = 3; // Cutoff in (local) sigma
	double spread = 0; // Additional local energy sigma
};
void psd_frommoments(const double* in, double* out, int N, const void* arg_);
double* calc_moments(double* data, int npts, int nslices);

#endif
