/*
* libselav - a framework for semi-lagrangian simulation of sparse densities
* Copyright (C) 2020-2022  Philipp Amstutz (DESY)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef SLV_MAIN_H
#define SLV_MAIN_H

#include "bessel.h"
#include "cell.h"
#include "debug.h"
#include "eps.h"
#include "functions.h"
#include "interpolate.h"
#include "maps.h"
#include "math_eval.h"
#include "merge.h"
#include "poisson.h"
#include "poisson1d.h"
#include "csr.h"
#include "noise.h"
#include "psd_ensemble.h"
#include "psd_eval.h"
#include "psd_fill.h"
#include "psd_frommoments.h"
#include "psd.h"
#include "psd_projection.h"
#include "psd_save.h"
#include "psd_step.h"
#include "psd_write.h"
#include "psd_plot.h"
#include "psd_stats.h"
#include "psd_dotgraph.h"
#include "read_ensembles.h"
#include "accphys.h"
//#include "X.h"

#endif
