/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 19 "src/selav1d/main.y"


#include <stdio.h>
#include <string>
#include <cstring>
#include <vector>
#include <error.h>
#include <map>
#include <set>
#include <unistd.h>
//#include <sys/types.h>
#include <sys/stat.h>


#include "selav.h"
#ifdef HAVE_X11
#include "X.h"
#endif
#include "var.h"


extern int yylex();
extern int yyparse();
extern FILE* yyin;
void yyerror(const char* s);

/* switch buffer; defined in .l */
extern void parse_file__(const char*);
extern void parse_string__(const char*);
extern void print_buffer_position();

environment ENV;
FILE* OUTFILE; // FIXME: If this declaration is before the ENV declaration
               //        we get segfaults on the first print.

/* ---------------- DEFAULTS -------------- */
namespace def {
	const int psd_depth = 7;
	const int psd_nexp = 2;
	const double psd_xmin = -1.0;
	const double psd_ymin = -1.0;
	const double psd_xmax =  1.0;
	const double psd_ymax =  1.0;

	const SLV::map_cavity_args map_cavity_args = {1e9, 0, 1e6, 0};
	const SLV::map_chicanec_args map_chicanec_args = {10, 0.5, 0.5, 0, 0};
	const double spacecharge_length = 1;
	const double spacecharge_beamsize = 1;
}


/* ---------------- CONSTANTS ------------- */
namespace cnst {
	static double c       = 299792458.0;      // Speed of light [m/s]
	static double eps0    = 8.8541878128e-12; // E-Field const [C/Vm]
	static double m_e     = 9.1093837015e-31; // Mass electron [kg]
	static double q_e     = -1.602176634e-19; // Charge electron [C]
	static double m_e_eV  = m_e*c*c / -q_e;   // Rest Energy electron [eV]
}


void accept_kwargs(environment* kwargs, std::set<std::string> accept) {
	for(auto& arg : *kwargs) {
		if (accept.find(arg.first) == accept.end()) {
			print_buffer_position();
			error(1,0,"Error: Keyword '%s' not recognized",arg.first.c_str());
		}
	}
}

/* ---------- PSD input ------------ */

SLV::psd<2>*  psd_from_kwargs(environment* kwargs, double* limits=NULL) {
	double xmin = def::psd_xmin;
	double ymin = def::psd_ymin;
	double xmax = def::psd_xmax;
	double ymax = def::psd_ymax;
	double weight = 1;
	int depth   = def::psd_depth;
	int nexp    = def::psd_nexp;
	int interpolation = 2;
	int topology = 0;
	for(auto& arg : *kwargs) {
		if      (arg.first == "depth")   depth = arg.second->fval[0];
		else if (arg.first == "nexp")    nexp = arg.second->fval[0];
		else if (arg.first == "weight")  weight = arg.second->fval[0];
		else if (arg.first == "limits") {
			assert(arg.second->size==4);
			limits = arg.second->fval;
		}
		else if (arg.first == "interpolation")  interpolation = arg.second->fval[0];
		else if (arg.first == "topology")  topology = arg.second->fval[0];
	}
	if(limits) {
		xmin = limits[0];
		ymin = limits[1];
		xmax = limits[2];
		ymax = limits[3];
	}
	auto psd = new SLV::psd<2>({(xmax+xmin)/2,(ymax+ymin)/2},{(xmax-xmin)/2,(ymax-ymin)/2});
	psd->depth = depth;
	psd->nexp = nexp;
	psd->weight = weight;
	psd->interpolation = interpolation;
	psd->set_topology(topology);

	return psd;
}

SLV::psd<2>*  psd_analytic__(char* fstr, environment* kwargs) {
	accept_kwargs(kwargs,{"depth","nexp","weight","limits","map","interpolation","topology"});
	SLV::psd<2>* psd = psd_from_kwargs(kwargs);
	mapwargs_t map = {NULL,NULL};
	for(auto& arg : *kwargs) {
		if (arg.first == "map")      map = *arg.second->mapval;
	}

	char b[16] = "q\0p\0";
	char* names[2] = {b,b+2};
	struct math_eval_args args = {fstr,names};
	SLV::fill(psd,eval_math<2>,&args,map.map,map.args,1);
	return psd;
}

SLV::psd<2>*  psd_gauss__(environment* kwargs) {
	accept_kwargs(kwargs,{"depth","nexp","weight","sig_q","sig_p","correlation","cutoff","limits","map","interpolation","topology"});
	struct gauss2D_args fargs = {0.2,0.2,0,3};
	mapwargs_t map = {NULL,NULL};
	for(auto& arg : *kwargs) {
		if      (arg.first == "sig_q") fargs.sig_q = arg.second->fval[0];
		else if (arg.first == "sig_p") fargs.sig_p = arg.second->fval[0];
		else if (arg.first == "correlation") fargs.correlation = arg.second->fval[0];
		else if (arg.first == "cutoff") fargs.cutoff = arg.second->fval[0];
		else if (arg.first == "map")      map = *arg.second->mapval;
	}
	double limits[4] = {
		-(fargs.cutoff+1)*fargs.sig_q,
		-(fargs.cutoff+1)*fargs.sig_p,
		 (fargs.cutoff+1)*fargs.sig_q,
		 (fargs.cutoff+1)*fargs.sig_p,
	};
	SLV::psd<2>* psd = psd_from_kwargs(kwargs,limits);
	SLV::fill(psd,gauss2D,&fargs,map.map,map.args,1);
	return psd;
}


void ensemble_bbox(const double* data, double* limits, size_t N, int dim) {
	// find limits
	for(int d=0; d<dim; d++) {
		limits[d+0*dim] =  INFINITY;
		limits[d+1*dim] = -INFINITY;
	}
	double* lim;
	for(size_t i=0; i<N*dim; i++) {
		int d = i%dim;
		lim = limits+d;
		*lim = data[i]<*lim ? data[i]: *lim;
		lim = limits+d+dim;
		*lim = data[i]>*lim ? data[i]: *lim;
	}
}

static inline double max(double a, double b) {
	return a>b?a:b;
}

SLV::psd<2>*  psd_ensemble__(char* fname, environment* kwargs) {
	accept_kwargs(kwargs,{"nslices","cutoff","weight","spread","depth","nexp","limits","map","interpolation","topology","type"});

	struct ensemble_t (*read_method)(FILE*) = read_ensemble;
	for(auto& arg : *kwargs) {
		if(arg.first == "type") {
		     	if(strcmp(arg.second->sval,"astra")==0) read_method = read_astra;
		     	if(strcmp(arg.second->sval,"plain")==0) read_method = read_ensemble;
		}
	}

	// Read ensemble
	FILE* fd = fopen(fname,"r");
	if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); };
	struct ensemble_t ens = read_method(fd);
	fclose(fd);

	// Calculate bbox
	double limits[4];
	ensemble_bbox(ens.data,limits,ens.N,2);


	// Gather arguments
	psd_frommoments_args args;
	args.limits[0] = limits[0],
	args.limits[1] = limits[2];
	args.nslices = 32;
	args.cutoff  = 3;
	args.spread  = 0.0;
	mapwargs_t map = {NULL,NULL};
	double* weight = &ens.weight;
	bool limits_given = 0;
	for(auto& arg : *kwargs) {
		if      (arg.first == "nslices") args.nslices = arg.second->fval[0];
		else if (arg.first == "cutoff")  args.cutoff = arg.second->fval[0];
		else if (arg.first == "spread")  args.spread = arg.second->fval[0];
		else if (arg.first == "map")     map = *arg.second->mapval;
		else if (arg.first == "limits")  limits_given=true;
		else if (arg.first == "weight")  weight = arg.second->fval;
	}
	// Moments
	args.moments = calc_moments(ens.data,ens.N,args.nslices);

	SLV::psd<2>* psd = psd_from_kwargs(kwargs);
	psd->weight = *weight;
	psd->refpoint[1] = ens.reference[1];
	if(!limits_given) {
		psd->root->cpoint = {(limits[2]+limits[0])/2,(limits[3]+limits[1])/2};
		psd->root->cwidth = {(limits[2]-limits[0])/2,(limits[3]-limits[1])/2};
	}

	SLV::fill(psd,psd_frommoments,&args,map.map,map.args,1);

	free(ens.data);
	free(args.moments);
	return psd;
}

SLV::psd<2>*  psd_rectangle__(double* limits, environment* kwargs) {
	accept_kwargs(kwargs,{"depth","weight","nexp","limits","interpolation","topology"});
	SLV::psd<2>* psd = psd_from_kwargs(kwargs);
	SLV::fill(psd,rectangle,limits,NULL,NULL,1);
	return psd;
}

SLV::psd<2>*  psd_test__(environment* kwargs) {
	accept_kwargs(kwargs,{"depth","weight","nexp","limits","interpolation","topology"});
	double c=2;
	SLV::psd<2>* psd = psd_from_kwargs(kwargs);
	SLV::fill(psd,smiley2D,&c,NULL,NULL,1);
	return psd;
}

SLV::psd<2>*  psd_bump__(environment* kwargs) {
	accept_kwargs(kwargs,{"depth","weight","nexp","limits","interpolation","topology","sig_p","cutoff","width","dropoff","chirp"});
	SLV::psd<2>* psd = psd_from_kwargs(kwargs);
	double args[] = {0.1,5,0.5,0.1,0.0}; // sigma,cutoff,a,d,chirp
	for(auto& arg : *kwargs) {
		if      (arg.first == "sig_p")   args[0] = arg.second->fval[0];
		if      (arg.first == "cutoff")  args[1] = arg.second->fval[0];
		if      (arg.first == "width")   args[2] = arg.second->fval[0];
		if      (arg.first == "dropoff") args[3] = arg.second->fval[0];
		if      (arg.first == "chirp")   args[4] = arg.second->fval[0];
	}
	SLV::fill(psd,bump,&args,NULL,NULL,1);
	return psd;
}

/* ----------- MAPS ---------------- */

mapwargs_t* map_compose__(varlist* vl) {
	SLV::map_compose_args* args = new SLV::map_compose_args();
	args->n = vl->size();
	for(size_t i=0; i<vl->size(); i++) {
		args->maps[i] = (*vl)[i]->mapval->map;
		args->args[i] = (*vl)[i]->mapval->args;
	}
	return new mapwargs_t({SLV::map_compose,args});
}


mapwargs_t* map_translate__(const double* delta) {
	double* d = (double*) malloc(2*sizeof(double));
	memcpy(d,delta,2*sizeof(double));
	typedef SLV::map_translate_args arg_t;
	arg_t* margs = (arg_t*) malloc(sizeof(arg_t));
	*margs = {d,2};
	return new mapwargs_t({SLV::map_translate,margs});
}

mapwargs_t* map_rotate__(double a) {
	double* angle = (double*)  calloc(1,sizeof(double));
	*angle = a;
	return new mapwargs_t({SLV::map_rotate,angle});
}

mapwargs_t*  map_driftl__(double _d) {
	double* d = (double*)  calloc(1,sizeof(double));
	*d = _d;
	return new mapwargs_t({SLV::map_driftl,d});
}

mapwargs_t*  map_kickl__(double _k) {
	double* k = (double*)  calloc(1,sizeof(double));
	*k = _k;
	return new mapwargs_t({SLV::map_kickl,k});
}

mapwargs_t*  map_hyperbolic__(double _a) {
	double* a = (double*)  calloc(1,sizeof(double));
	*a = _a;
	return new mapwargs_t({SLV::map_hyperbolic,a});
}

mapwargs_t*  map_driftpoly__(int n, double* factors) {
	struct SLV::map_driftpoly_args* args = (struct SLV::map_driftpoly_args*) malloc(sizeof(struct SLV::map_driftpoly_args));
	args->n = n;
	memcpy(args->factors,factors,n*sizeof(double));
	return new mapwargs_t({SLV::map_driftpoly,args});
}

mapwargs_t*  map_kickpoly__(int n, double* factors) {
	struct SLV::map_kickpoly_args* args = (struct SLV::map_kickpoly_args*) malloc(sizeof(struct SLV::map_kickpoly_args));
	args->n = n;
	memcpy(args->factors,factors,n*sizeof(double));
	return new mapwargs_t({SLV::map_kickpoly,args});
}

mapwargs_t*  map_driftsine__(double a, double k, double phi) {
	double* args = (double*)  calloc(3,sizeof(double));
	args[0]=a; args[1]=k; args[2]=phi;
	return new mapwargs_t({SLV::map_driftsine,args});
}

mapwargs_t*  map_kicksine__(double a, double k, double phi) {
	double* args = (double*)  calloc(3,sizeof(double));
	args[0]=a; args[1]=k; args[2]=phi;
	return new mapwargs_t({SLV::map_kicksine,args});
}

mapwargs_t*  map_cavity__(environment* kwargs) {
	accept_kwargs(kwargs,{"freq","phase","ampl","mode"});
	typedef SLV::map_cavity_args arg_t;
	arg_t* margs = (arg_t*) malloc(sizeof(arg_t));
	*margs = def::map_cavity_args;
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		     if ( kw == "freq")  margs->freq  = v->fval[0];
		else if ( kw == "phase") margs->phase = v->fval[0];
		else if ( kw == "ampl")  margs->ampl  = v->fval[0];
		else if ( kw == "mode")  margs->mode  = v->fval[0];
	}
	//fprintf(stderr,"delta_E: %e\n",margs->ampl *  cos( margs->phase ));
	return new mapwargs_t({SLV::map_cavity,margs});
}

mapwargs_t*  map_chicanec__(environment* kwargs) {
	accept_kwargs(kwargs,{"alpha","lD","lB","energy","mode","verbose","name"});
	char* name = NULL;
	bool verbose = 0;
	typedef SLV::map_chicanec_args arg_t;
	arg_t* margs = (arg_t*) malloc(sizeof(arg_t));
	*margs = def::map_chicanec_args;
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		     if ( kw == "alpha")   margs->alpha  = v->fval[0];
		else if ( kw == "lD")      margs->lD     = v->fval[0];
		else if ( kw == "lB")      margs->lB     = v->fval[0];
		else if ( kw == "energy")  margs->energy = v->fval[0];
		else if ( kw == "mode")    margs->mode   = v->fval[0];
		else if ( kw == "verbose") verbose       = v->fval[0];
		else if ( kw == "name")    name          = v->sval;
	}

	char pref[256]={0};
	if(name) sprintf(pref,"%s_",name);
	if(verbose) {
		fprintf(OUTFILE,"%smode:   %d\n",pref,margs->mode);
		fprintf(OUTFILE,"%salpha:  %e\n",pref,margs->alpha);
		fprintf(OUTFILE,"%slD:     %e\n",pref,margs->lD);
		fprintf(OUTFILE,"%slB:     %e\n",pref,margs->lB);
		fprintf(OUTFILE,"%sR56:    %e\n",pref,SLV::chicanec_R56(margs->alpha,margs->lB,margs->lD));
		fprintf(OUTFILE,"%senergy: %e\n",pref,margs->energy);
	}
	return new mapwargs_t({SLV::map_chicanec,margs});
}

mapwargs_t*  map_csr__(const SLV::psd<2>* psd, environment* kwargs) {
	accept_kwargs(kwargs,{"angle","s","ds","length","file","energy",
		"npad","fudge","debug","verbose","mode","filter",
		"filterwidth","large_dist_cutoff","transient"});

	double angle = 1;
	double length = 1;
	double s  = -1;
	double ds = -1;
	double energy = cnst::m_e_eV;
	int npad = 2;
	char* fname = NULL;
	double fudge = 1.0;
	char* debug = NULL;
	bool verbose = 0;
	char mode = 5;
	char filter = 0;
	double filterwidth = 1./10.;
	double large_dist_cutoff = 0;
	int transient = 1;

	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		     if ( kw == "angle")   angle   = v->fval[0];
		else if ( kw == "length")  length  = v->fval[0];
		else if ( kw == "s")       s       = v->fval[0];
		else if ( kw == "ds")      ds      = v->fval[0];
		else if ( kw == "energy")  energy  = v->fval[0];
		else if ( kw == "npad")    npad    = v->fval[0];
		else if ( kw == "file")    fname   = v->sval;
		else if ( kw == "fudge")   fudge   = v->fval[0];
		else if ( kw == "debug")   debug   = v->sval;
		else if ( kw == "verbose") verbose = v->fval[0];
		else if ( kw == "mode")    mode    = v->fval[0];
		else if ( kw == "filter")  filter  = v->fval[0];
		else if ( kw == "filterwidth") filterwidth = v->fval[0];
		else if ( kw == "large_dist_cutoff") large_dist_cutoff = v->fval[0];
		else if ( kw == "transient") transient = v->fval[0];
	}
	// set s, ds defaults
	if(s<0)   s = length;
	if(ds<0) ds = length;

	double gamma = energy / cnst::m_e_eV;

	struct SLV::grid_t p = SLV::psd_projection(psd,2);
	const size_t npts = 1u<<p.nexp;
	double* sol = (double*) calloc(npts,sizeof(double));

	//solve_poisson_args args = {
	//	.T=(p.limits[1]-p.limits[0]),
	//	.npad = npad,
	//	.green_s = NULL,
	//	.green_f = green_f_csr,
	//	.fargs= &radius
	//};
	//solve_poisson(p.data,sol,npts,(void*) &args, prefix);

	solve_csr_args args = {
		.T=(p.limits[1]-p.limits[0]),
		.npad = npad,
		.length = length,
		.angle = angle,
		.s = s,
		.gamma = gamma,
		.mode = mode,
		.filter = filter,
		.filterwidth = filterwidth,
		.transient = transient,
		.large_dist_cutoff = large_dist_cutoff
	};

	if(mode>=0 && mode<=5) {
		solve_csr(p.data,sol,npts,(void*) &args, debug);
	} else if(mode==99) {
		solve_csr_old(p.data,sol,npts,(void*) &args, debug);
	} else {
		fprintf(stderr,"csr mode %d unknown\n",mode); exit(1);
	}

	double factor =
			// conv(rho,G) // 1/m^2
			//length                   // m
			psd->weight            // C
			/// (4.0*M_PI*cnst::eps0) // Vm/C
			/ (4.0*M_PI*cnst::eps0) // Vm/C
			/// gamma                 // 1
			* fudge
			* ds
		;
	typedef SLV::map_datakick_args arg_t;
	arg_t* margs = (arg_t*) malloc(sizeof(arg_t));
	*margs = {
		.data=sol,
		.limits=p.limits,
		.dim=2,
		.dim_q=0,
		.dim_p=1,
		.npts=npts,
		.factor=factor
	};

	if(verbose) {
		fprintf(OUTFILE,"length: %e\n",    length);
		fprintf(OUTFILE,"angle:  %e\n",    angle);
		fprintf(OUTFILE,"s:      %e\n",    s);
		fprintf(OUTFILE,"ds:     %e\n",    ds);
		fprintf(OUTFILE,"energy: %e\n",    energy);
		fprintf(OUTFILE,"gamma:  %e\n",    gamma);
		fprintf(OUTFILE,"factor: %e\n",    factor);
		fprintf(OUTFILE,"weight: %e\n",    psd->weight);
		fprintf(OUTFILE,"T:      %e\n",    args.T);
		fprintf(OUTFILE,"limits: %e %e\n", p.limits[0],p.limits[1]);
		fprintf(OUTFILE,"mode:   %d\n",    args.mode);
	}

	if(fname!=NULL) {
		FILE* fd = fopen(fname,"w");
		if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); }
		fprintf(fd,"q rho field\n");
		for(size_t i=0; i<margs->npts; i++) {
			double q = margs->limits[0] + (margs->limits[1]-margs->limits[0])/margs->npts * i;
			fprintf(fd,"%e %e %e\n",q,p.data[i],sol[i]*factor/ds);
		}
		fclose(fd);
	}
	free(p.data);
	return new mapwargs_t({SLV::map_datakick,margs});
}


mapwargs_t*  map_spacecharge__(const SLV::psd<2>* psd, environment* kwargs) {
	accept_kwargs(kwargs,{"beamsize","length","file","energy","npad","fudge","debug","verbose","beamsize_factor"});

	double beamsize = def::spacecharge_beamsize;
	double length = def::spacecharge_length;
	double energy = cnst::m_e_eV;
	int npad = 2;
	char* fname = NULL;
	double fudge = 1.0;
	double beamsize_factor = 1.747;
	char* debug = NULL;
	bool verbose = 0;

	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		     if ( kw == "beamsize") beamsize  = v->fval[0];
		else if ( kw == "length")   length    = v->fval[0];
		else if ( kw == "energy")   energy    = v->fval[0];
		else if ( kw == "npad")     npad      = v->fval[0];
		else if ( kw == "file")     fname     = v->sval;
		else if ( kw == "fudge")    fudge     = v->fval[0];
		else if ( kw == "beamsize_factor") beamsize_factor = v->fval[0];
		else if ( kw == "debug")    debug     = v->sval;
		else if ( kw == "verbose")  verbose   = v->fval[0];
	}

	double gamma = energy / cnst::m_e_eV;
	double beamradius = beamsize * beamsize_factor;

	struct SLV::grid_t p = SLV::psd_projection(psd,2);
	solve_poisson_args args = {
		.T=(p.limits[1]-p.limits[0])*gamma,
		.npad = npad,
		.green_s = NULL,
		.green_f = green_f_adisk,
		.fargs = &beamradius
	};
	const size_t npts = 1u<<p.nexp;
	double* sol = (double*) calloc(npts,sizeof(double));
	solve_poisson(p.data,sol,npts,(void*) &args, debug);

	double factor =
			// conv(rho,G) // 1/m^2
			length                   // m
			* psd->weight            // C
			/// (4.0*M_PI*cnst::eps0) // Vm/C
			/ (2.0*M_PI*cnst::eps0) // Vm/C // see mthesis
			/ gamma                  // 1
			* fudge
		;
	typedef SLV::map_datakick_args arg_t;
	arg_t* margs = (arg_t*) malloc(sizeof(arg_t));
	*margs = {
		.data=sol,
		.limits=p.limits,
		.dim=2,
		.dim_q=0,
		.dim_p=1,
		.npts=npts,
		.factor=factor
	};

	if(verbose) {
		fprintf(OUTFILE,"length: %e\n",    length);
		fprintf(OUTFILE,"energy:  %e\n",   energy);
		fprintf(OUTFILE,"gamma:  %e\n",    gamma);
		fprintf(OUTFILE,"factor: %e\n",    factor);
		fprintf(OUTFILE,"weight: %e\n",    psd->weight);
		fprintf(OUTFILE,"T:      %e\n",    args.T);
		fprintf(OUTFILE,"limits: %e %e\n", p.limits[0],p.limits[1]);
		fprintf(OUTFILE,"beamsize: %e\n",        beamsize);
		fprintf(OUTFILE,"beamsize_factor: %e\n", beamsize_factor);
		fprintf(OUTFILE,"beamradius: %e\n",      beamradius);
	}

	if(fname!=NULL) {
		FILE* fd = fopen(fname,"w");
		if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); }
		fprintf(fd,"q rho field\n");
		for(size_t i=0; i<margs->npts; i++) {
			double q = margs->limits[0] + (margs->limits[1]-margs->limits[0])/margs->npts * i;
			fprintf(fd,"%e %e %e\n",q,p.data[i],sol[i]*factor/length);
		}
		fclose(fd);
	}
	free(p.data);
	return new mapwargs_t({SLV::map_datakick,margs});
}

mapwargs_t*  map_poisson__(const SLV::psd<2>* psd, char* fnc, environment* kwargs) {
	accept_kwargs(kwargs,{"npad","file"});
	int npad=2;
	char* fname = NULL;
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		     if ( kw == "npad") npad = v->fval[0];
		     else if ( kw == "file") fname = v->sval;
	}
	
	static char b[] = "q";
	char* varname = b;
	struct math_eval_args mathevalargs {
		.fstr = fnc,
		.names = &varname
	};
	struct SLV::grid_t p = SLV::psd_projection(psd,2);
	solve_poisson_args args = {
		.T=(p.limits[1]-p.limits[0]),
		.npad = npad,
		.green_s = eval_math<1>,
		.green_f = NULL,
		.fargs = &mathevalargs
	};
	const size_t npts = 1u<<p.nexp;
	double* sol = (double*) calloc(npts,sizeof(double));
	solve_poisson(p.data,sol,npts,(void*) &args);

	typedef SLV::map_datakick_args arg_t;
	arg_t* margs = (arg_t*) malloc(sizeof(arg_t));
	*margs = {
		.data=sol,
		.limits=p.limits,
		.dim=2,
		.dim_q=0,
		.dim_p=1,
		.npts=npts,
		.factor=1
	};

	if(fname!=NULL) {
		FILE* fd = fopen(fname,"w");
		if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); }
		for(size_t i=0; i<margs->npts; i++) {
			double q = margs->limits[0] + (margs->limits[1]-margs->limits[0])/margs->npts * i;
			fprintf(fd,"%e %e %e\n",q,p.data[i],sol[i]);
		}
		fclose(fd);
	}
	free(p.data);
	return new mapwargs_t({SLV::map_datakick,margs});
}

mapwargs_t*  map_poisson1d__(const SLV::psd<2>* psd, environment* kwargs) {
	accept_kwargs(kwargs,{"factor","file"});
	char* fname = NULL;
	double factor = 1;
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		     if ( kw == "factor") factor = v->fval[0];
		     else if ( kw == "file") fname = v->sval;
	}

	struct SLV::grid_t p = SLV::psd_projection(psd,2);
	const size_t npts = 1u<<p.nexp;
	solve_poisson1d_args args = {
		.T=(p.limits[1]-p.limits[0]),
		.npad = 1,
	};
	double* sol = (double*) calloc(npts,sizeof(double));
	solve_poisson1d(p.data,sol,npts,(void*) &args);
	typedef SLV::map_datakick_args arg_t;
	arg_t* margs = (arg_t*) malloc(sizeof(arg_t));
	*margs = {
		.data=sol,
		.limits=p.limits,
		.dim=2,
		.dim_q=0,
		.dim_p=1,
		.npts=npts,
		.factor=factor
	};
	if(fname!=NULL) {
		FILE* fd = fopen(fname,"w");
		if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); }
		fprintf(fd,"q rho field\n");
		for(size_t i=0; i<margs->npts; i++) {
			double q = margs->limits[0] + (margs->limits[1]-margs->limits[0])/margs->npts * i;
			fprintf(fd,"%e %e %e\n",q,p.data[i],sol[i]*factor);
		}
		fclose(fd);
	}
	free(p.data);
	return new mapwargs_t({SLV::map_datakick,margs});
}

mapwargs_t*  map_analytic__(char* fq, char* fp) {
	static char b[16] = "t\0q\0p\0";
	typedef map_analytic_args arg_t;
	arg_t* margs = (arg_t*) malloc(sizeof(arg_t));
	margs->dim = 2;
	margs->fstrs[0] = strdup(fq); // TODO: This never gets freed
	margs->fstrs[1] = strdup(fp);
	margs->names[0] = b;
	margs->names[1] = b+2;
	margs->names[2] = b+4;
	return new mapwargs_t({map_analytic,margs});
}


mapwargs_t*  map_identity__() {
	return new mapwargs_t({SLV::map_identity,NULL});
}


/* ----------- Perron-Frobenius Step -------- */

SLV::psd<2>*  propagate__(const SLV::psd<2>* psd, mapwargs_t* map, environment* kwargs) {
	accept_kwargs(kwargs,{"center","box","nexp","depth","limits","pre","t","epsilon"});
	double t = 1;
	//SLV::psd_step_args args = {0,0,SLV::AUTO,SLV::AUTO,NULL,2,1e-12};
	SLV::psd_step_args args = {
		.nexp = 0,
		.depth = 0,
		.center_strat = SLV::AUTO,
		.box_strat = SLV::AUTO,
		.limits = NULL,
		.pre = 2,
		.epsilon = 1e-12
	};
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		     if ( kw == "center") {
		     	     if(strcmp(v->sval,"KEEP")==0) args.center_strat = SLV::KEEP;
		     	else if(strcmp(v->sval,"AUTO")==0) args.center_strat = SLV::AUTO;
			else {
				print_buffer_position();
				error(1,0,"%s unknown",v->sval);
			}
		     }
		     if ( kw == "box") {
		     	     if(strcmp(v->sval,"KEEP" )==0) args.box_strat = SLV::KEEP;
		     	else if(strcmp(v->sval,"EQUAL")==0) args.box_strat = SLV::EQUAL;
		     	else if(strcmp(v->sval,"AUTO" )==0) args.box_strat = SLV::AUTO;
		     	else if(strcmp(v->sval,"AREA" )==0) args.box_strat = SLV::AREA;
			else {
				print_buffer_position();
				error(1,0,"%s unknown",v->sval);
			}
		     }
		     if ( kw == "nexp") {
		     	     args.nexp = v->fval[0];
		     }
		     if ( kw == "depth") {
		     	     args.depth = v->fval[0];
		     }
		     if ( kw == "limits") {
		     	     args.limits = v->fval;
		     }
		     if ( kw == "pre") {
		     	     args.pre = v->fval[0];
		     }
		     if ( kw == "epsilon") {
		     	     args.epsilon = v->fval[0];
		     }
		     if ( kw == "t") {
		     	     t = v->fval[0];
		     }
	}
	return SLV::psd_step(psd,map->map,map->args,t,args);
}


/* ------------- Other Functions ------------ */

void show__(SLV::psd<2>* psd, environment* kwargs) {
	accept_kwargs(kwargs,{"file","cells","negative","limits","grid","contours","rectangle","projection","points","title"});
	#ifdef HAVE_X11
	xwindow vis;
	vis.fun = SLV::psd_eval<2>;
	vis.fargs=psd;
	vis.psd = psd;
	vis.root=psd->root;
	vis.center();
	char* fname=NULL;
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		if ( kw == "file") fname = v->sval;
		if ( kw == "title") vis.set_name(v->sval);
		if ( kw == "cells") {
			if(v->fval[0] > 0) {
				vis.drawmask |= vis.DRAWCELLS;
			} else {
				vis.drawmask &= ~vis.DRAWCELLS;
			}
		}
		if ( kw == "negative") {
			if(v->fval[0] > 0) {
				vis.drawmask |= vis.DRAWNEGATIVE;
			} else {
				vis.drawmask &= ~vis.DRAWNEGATIVE;
			}
		}
		if ( kw == "grid") {
			if(v->fval[0] > 0) {
				vis.drawmask |= vis.DRAWGRID;
			} else {
				vis.drawmask &= ~vis.DRAWGRID;
			}
		}
		if ( kw == "contours") {
			if(v->fval[0] > 0) {
				vis.drawmask |= vis.DRAWCONTOURS;
			} else {
				vis.drawmask &= ~vis.DRAWCONTOURS;
			}
		}
		if ( kw == "limits") {
			memcpy(vis.limits,v->fval,4*sizeof(double));
		}
		if ( kw == "rectangle") {
			memcpy(vis.rectangle,v->fval,4*sizeof(double));
			vis.drawmask |= vis.DRAWRECTANGLE;
		}
		if ( kw == "projection") {
			if(v->fval[0] > 0) {
				vis.drawmask |= vis.DRAWPROJECTION;
			} else {
				vis.drawmask &= ~vis.DRAWPROJECTION;
			}
		}
		if ( kw == "points") {
			if(v->fval[0] > 0) {
				vis.drawmask |= vis.DRAWPOINTS;
			} else {
				vis.drawmask &= ~vis.DRAWPOINTS;
			}
		}
	}
	if(fname!=NULL) {
		FILE* fd = fopen(fname,"w");
		if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); }
		vis.update();
		vis.screenshot(fd);
		fclose(fd);
	} else {
		//if(fork()) return;
		vis.loop();
		//_exit(0);
	}
	#else
	fprintf(stderr,"Visualization not available. Recompile with X11 support.\n");
	#endif
}

void plot__(SLV::psd<2>* psd, const char* fname, environment* kwargs) {
	FILE* fd = fopen(fname,"w");
	psd_plot(psd,fd);
	fclose(fd);
}


void write_projection__(SLV::psd<2>* psd, const char* fname, unsigned int dims, environment* kwargs) {
	accept_kwargs(kwargs,{"method"});
	int method = 0;
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		     if ( kw == "method") method = v->fval[0];
	}
	SLV::grid_t p = SLV::psd_projection(psd, dims, method);
	FILE* fd = fopen(fname,"w");
	if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); }
	int Nd = 1;
	int npts = 1<<(p.dim*p.nexp);

	double coords[p.dim * 1<<(p.nexp*p.dim)];
	for(int d=0; d<p.dim; d++) {
		for(int n=0; n < npts; n++) {
			int i = n*p.dim+d;
			coords[i] = ( (n/Nd) % (1<<p.nexp) ) * (1.0 / (1<<p.nexp));
			coords[i] = p.limits[d] + coords[i] * (p.limits[d+p.dim]-p.limits[d]);
		}
		Nd *= 1<<p.nexp;
	}

	// write header
	for(int d=0; d<p.dim; d++) {
		fprintf(fd,"z%d ",d);
	}
	fprintf(fd,"proj\n");

	// write data
	for(int i=0; i<npts; i++) {
		for(int d=0; d<p.dim; d++) {
			fprintf(fd,"%e ",coords[i*p.dim+d]);
		}
		fprintf(fd,"%0.16e\n",p.data[i]);
	}
	fclose(fd);
	free(p.data);
	free(p.limits);
}

void write_localmoments__(SLV::psd<2>* psd, const char* fname, unsigned int axis) {
	const int N=3;
	SLV::grid_t moments[N];
	double exps[2] = {0,0};
	struct monomial_args args = {2,exps};
	for(int n=0; n<N; n++) {
		exps[axis] = n;
		moments[n] = SLV::psd_projection(psd, 1<<axis, 0, monomial, &args);
	}

	FILE* fd = fopen(fname,"w");
	if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); }
	const size_t npts = 1<<(moments[N-1].nexp);

	fprintf(fd,"z rho mu std\n"); // write header
	for(size_t i=0; i<npts; i++) {
		double q = moments[0].limits[0] + i*(moments[0].limits[1]-moments[0].limits[0])/npts;
		double   u = moments[0].data[i];
		double  mu = u<=0 ? 0.0 : moments[1].data[i]/u;
		double var = u<=0 ? 0.0 : moments[2].data[i]/u - mu*mu;
		fprintf(fd,"%0.16e ",q);
		fprintf(fd,"%0.16e ",u);
		fprintf(fd,"%0.16e ",mu);
		fprintf(fd,"%0.16e",sqrt(var));
		fprintf(fd,"\n");
	}
	fclose(fd);

	for(int n=0; n<N; n++) {
		free(moments[n].data);
		free(moments[n].limits);
	}
}

void write_grid__(SLV::psd<2>* psd, const char* fname , environment* kwargs) {
	accept_kwargs(kwargs,{"npts","limits"});
	int npts[2] = {128,128};
	double* limits = NULL;
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		if( kw == "npts") {
			npts[0] = v->fval[0];
			npts[1] = v->fval[1];
		}
		if( kw == "limits") limits = v->fval;
	}
	FILE* fd = fopen(fname,"w");
	if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); };
	psd_write_grid(psd,fd,limits,npts);
	fclose(fd);
}

void write_ensemble__(SLV::psd<2>* psd, const char* fname , environment* kwargs) {
	accept_kwargs(kwargs,{"n","form","seed","ref"});
	int n = 10*1000;
	int form = 0;
	int seed = 1337;
	double ref[2] = {0};
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		if( kw == "n")       n = v->fval[0];
		if( kw == "form") form = v->fval[0];
		if( kw == "seed") seed = v->fval[0];
		if( kw == "ref") { // reference
			if(v->size!=2) { print_buffer_position(); fprintf(stderr,"Error: size of 'ref' need to be 2\n"); exit(1); };
			ref[0] = v->fval[0];
			ref[1] = v->fval[1];
		}
	}
	FILE* fd = fopen(fname,"w");
	if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); };
	switch(form) {
		case 0:
			SLV::psd_ensemble(psd,fd,n,seed,ref);
			break;
		case 1:
			SLV::psd_ensemble_astra(psd,fd,n,seed,ref);
			break;
	}
	fclose(fd);
}

void modify__(SLV::psd<2>* psd, char* fstr) {
	char b[16] = "psi\0q\0p\0";
	char* names[3] = {b,b+4,b+6};
	struct math_eval_args args = {fstr,names};
	psd->modify(eval_mathf<2>,&args);
}

void noise__(SLV::psd<2>* psd, double a, environment* kwargs) {
	accept_kwargs(kwargs,{"type","seed"});
	int type = 0;
	int seed = 0;
	for(auto& arg : *kwargs) {
		std::string kw = arg.first;
		var* v = arg.second;
		if( kw == "seed") seed = v->fval[0];
		if( kw == "type") type = v->fval[0];
	}
	switch(type) {
	case 0:
		SLV::noise_uniform(psd->root, a);
		break;
	case 1:
		SLV::noise_poisson(psd->root, a, seed);
		break;
	default:
		print_buffer_position();
		error(1, 0, "Error: Noise type %d unknown (possible values: 0,1)\n",type);
		break;
	}
}

double integral_function__(SLV::psd<2>* psd, char* fstr) {
	char b[16] = "psi\0q\0p\0";
	char* names[3] = {b,b+4,b+6};
	struct math_eval_args args = {fstr,names};
	return psd->integral(eval_mathf<2>,&args);
}

FILE* fdstack[128];
FILE** fdstack_ptr = fdstack;

void fdstack_push(FILE* fd) {
	fdstack_ptr++;
	*fdstack_ptr = fd;
	OUTFILE = *fdstack_ptr;
}
void fdstack_pop() {
	fclose(OUTFILE);
	fdstack_ptr--;
	OUTFILE = *fdstack_ptr;
}



#line 1116 "src/selav1d/main.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "main.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_WHO = 3,                        /* WHO  */
  YYSYMBOL_FORMAT = 4,                     /* FORMAT  */
  YYSYMBOL_STRCAT = 5,                     /* STRCAT  */
  YYSYMBOL_GTGT = 6,                       /* GTGT  */
  YYSYMBOL_GT = 7,                         /* GT  */
  YYSYMBOL_LT = 8,                         /* LT  */
  YYSYMBOL_GE = 9,                         /* GE  */
  YYSYMBOL_LE = 10,                        /* LE  */
  YYSYMBOL_EQ = 11,                        /* EQ  */
  YYSYMBOL_NE = 12,                        /* NE  */
  YYSYMBOL_PLUS = 13,                      /* PLUS  */
  YYSYMBOL_MINUS = 14,                     /* MINUS  */
  YYSYMBOL_TIMES = 15,                     /* TIMES  */
  YYSYMBOL_DIVIDE = 16,                    /* DIVIDE  */
  YYSYMBOL_COLONEQUAL = 17,                /* COLONEQUAL  */
  YYSYMBOL_POW = 18,                       /* POW  */
  YYSYMBOL_UMINUS = 19,                    /* UMINUS  */
  YYSYMBOL_UPLUS = 20,                     /* UPLUS  */
  YYSYMBOL_SIN = 21,                       /* SIN  */
  YYSYMBOL_COS = 22,                       /* COS  */
  YYSYMBOL_ASIN = 23,                      /* ASIN  */
  YYSYMBOL_ACOS = 24,                      /* ACOS  */
  YYSYMBOL_TAN = 25,                       /* TAN  */
  YYSYMBOL_ATAN2 = 26,                     /* ATAN2  */
  YYSYMBOL_SQRT = 27,                      /* SQRT  */
  YYSYMBOL_FLOOR = 28,                     /* FLOOR  */
  YYSYMBOL_CEIL = 29,                      /* CEIL  */
  YYSYMBOL_ABS = 30,                       /* ABS  */
  YYSYMBOL_RBRACKET = 31,                  /* RBRACKET  */
  YYSYMBOL_LBRACKET = 32,                  /* LBRACKET  */
  YYSYMBOL_FLOAT = 33,                     /* FLOAT  */
  YYSYMBOL_STRING = 34,                    /* STRING  */
  YYSYMBOL_SYMBOL = 35,                    /* SYMBOL  */
  YYSYMBOL_BLOCK = 36,                     /* BLOCK  */
  YYSYMBOL_SHOW = 37,                      /* SHOW  */
  YYSYMBOL_PLOT = 38,                      /* PLOT  */
  YYSYMBOL_EVAL = 39,                      /* EVAL  */
  YYSYMBOL_INCLUDE = 40,                   /* INCLUDE  */
  YYSYMBOL_PRINT = 41,                     /* PRINT  */
  YYSYMBOL_SAVE = 42,                      /* SAVE  */
  YYSYMBOL_LOAD = 43,                      /* LOAD  */
  YYSYMBOL_COPY = 44,                      /* COPY  */
  YYSYMBOL_STATS = 45,                     /* STATS  */
  YYSYMBOL_CENTROID = 46,                  /* CENTROID  */
  YYSYMBOL_VARIANCE = 47,                  /* VARIANCE  */
  YYSYMBOL_MAXIMUM = 48,                   /* MAXIMUM  */
  YYSYMBOL_REFERENCE = 49,                 /* REFERENCE  */
  YYSYMBOL_MAP_COMPOSE = 50,               /* MAP_COMPOSE  */
  YYSYMBOL_MAP_TRANSLATE = 51,             /* MAP_TRANSLATE  */
  YYSYMBOL_MAP_ROTATE = 52,                /* MAP_ROTATE  */
  YYSYMBOL_MAP_KICKL = 53,                 /* MAP_KICKL  */
  YYSYMBOL_MAP_IDENTITY = 54,              /* MAP_IDENTITY  */
  YYSYMBOL_MAP_HYPERBOLIC = 55,            /* MAP_HYPERBOLIC  */
  YYSYMBOL_MAP_CAVITY = 56,                /* MAP_CAVITY  */
  YYSYMBOL_MAP_DRIFTL = 57,                /* MAP_DRIFTL  */
  YYSYMBOL_MAP_CHICANEC = 58,              /* MAP_CHICANEC  */
  YYSYMBOL_MAP_SPACECHARGE = 59,           /* MAP_SPACECHARGE  */
  YYSYMBOL_MAP_CSR = 60,                   /* MAP_CSR  */
  YYSYMBOL_MAP_ANALYTIC = 61,              /* MAP_ANALYTIC  */
  YYSYMBOL_MAP_DRIFTPOLY = 62,             /* MAP_DRIFTPOLY  */
  YYSYMBOL_MAP_KICKPOLY = 63,              /* MAP_KICKPOLY  */
  YYSYMBOL_MAP_DRIFTSINE = 64,             /* MAP_DRIFTSINE  */
  YYSYMBOL_MAP_KICKSINE = 65,              /* MAP_KICKSINE  */
  YYSYMBOL_MAP_POISSON = 66,               /* MAP_POISSON  */
  YYSYMBOL_MAP_POISSON1D = 67,             /* MAP_POISSON1D  */
  YYSYMBOL_PSD_ANALYTIC = 68,              /* PSD_ANALYTIC  */
  YYSYMBOL_PSD_GAUSS = 69,                 /* PSD_GAUSS  */
  YYSYMBOL_PSD_ENSEMBLE = 70,              /* PSD_ENSEMBLE  */
  YYSYMBOL_PSD_RECTANGLE = 71,             /* PSD_RECTANGLE  */
  YYSYMBOL_PSD_TEST = 72,                  /* PSD_TEST  */
  YYSYMBOL_PSD_BUMP = 73,                  /* PSD_BUMP  */
  YYSYMBOL_PROPAGATE = 74,                 /* PROPAGATE  */
  YYSYMBOL_MULTIPLY = 75,                  /* MULTIPLY  */
  YYSYMBOL_MODIFY = 76,                    /* MODIFY  */
  YYSYMBOL_NOISE = 77,                     /* NOISE  */
  YYSYMBOL_NORMALIZE = 78,                 /* NORMALIZE  */
  YYSYMBOL_WRITE_PROJECTION = 79,          /* WRITE_PROJECTION  */
  YYSYMBOL_WRITE_LOCALMOMENTS = 80,        /* WRITE_LOCALMOMENTS  */
  YYSYMBOL_WRITE_GRID = 81,                /* WRITE_GRID  */
  YYSYMBOL_WRITE_ENSEMBLE = 82,            /* WRITE_ENSEMBLE  */
  YYSYMBOL_INTEGRAL = 83,                  /* INTEGRAL  */
  YYSYMBOL_CHARGE = 84,                    /* CHARGE  */
  YYSYMBOL_DO = 85,                        /* DO  */
  YYSYMBOL_FOR = 86,                       /* FOR  */
  YYSYMBOL_IN = 87,                        /* IN  */
  YYSYMBOL_IF = 88,                        /* IF  */
  YYSYMBOL_ELSE = 89,                      /* ELSE  */
  YYSYMBOL_DEFINED = 90,                   /* DEFINED  */
  YYSYMBOL_MKDIR = 91,                     /* MKDIR  */
  YYSYMBOL_CHDIR = 92,                     /* CHDIR  */
  YYSYMBOL_GETCWD = 93,                    /* GETCWD  */
  YYSYMBOL_GETENV = 94,                    /* GETENV  */
  YYSYMBOL_STRTOD = 95,                    /* STRTOD  */
  YYSYMBOL_STRCMP = 96,                    /* STRCMP  */
  YYSYMBOL_BASENAME = 97,                  /* BASENAME  */
  YYSYMBOL_LINSPACE = 98,                  /* LINSPACE  */
  YYSYMBOL_AVERAGE = 99,                   /* AVERAGE  */
  YYSYMBOL_TRANSFER4D = 100,               /* TRANSFER4D  */
  YYSYMBOL_CHICANECOEF = 101,              /* CHICANECOEF  */
  YYSYMBOL_ACCEPT = 102,                   /* ACCEPT  */
  YYSYMBOL_103_ = 103,                     /* ';'  */
  YYSYMBOL_104_ = 104,                     /* '('  */
  YYSYMBOL_105_ = 105,                     /* ')'  */
  YYSYMBOL_106_ = 106,                     /* ','  */
  YYSYMBOL_107_ = 107,                     /* '='  */
  YYSYMBOL_YYACCEPT = 108,                 /* $accept  */
  YYSYMBOL_input = 109,                    /* input  */
  YYSYMBOL_command = 110,                  /* command  */
  YYSYMBOL_psd_call = 111,                 /* psd_call  */
  YYSYMBOL_map_call = 112,                 /* map_call  */
  YYSYMBOL_assignment = 113,               /* assignment  */
  YYSYMBOL_var_flt = 114,                  /* var_flt  */
  YYSYMBOL_var_str = 115,                  /* var_str  */
  YYSYMBOL_var_psd = 116,                  /* var_psd  */
  YYSYMBOL_var_map = 117,                  /* var_map  */
  YYSYMBOL_var = 118,                      /* var  */
  YYSYMBOL_string = 119,                   /* string  */
  YYSYMBOL_array = 120,                    /* array  */
  YYSYMBOL_vars_flt = 121,                 /* vars_flt  */
  YYSYMBOL_vars = 122,                     /* vars  */
  YYSYMBOL_vars_map = 123,                 /* vars_map  */
  YYSYMBOL_exp = 124,                      /* exp  */
  YYSYMBOL_kwarg = 125,                    /* kwarg  */
  YYSYMBOL_kwargs = 126                    /* kwargs  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1519

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  108
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  19
/* YYNRULES -- Number of rules.  */
#define YYNRULES  126
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  492

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   357


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     104,   105,     2,     2,   106,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   103,
       2,   107,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1112,  1112,  1113,  1117,  1118,  1120,  1122,  1131,  1140,
    1145,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1188,  1193,
    1197,  1202,  1207,  1211,  1215,  1220,  1224,  1232,  1236,  1257,
    1263,  1272,  1276,  1280,  1285,  1290,  1294,  1298,  1303,  1311,
    1318,  1319,  1320,  1321,  1322,  1323,  1324,  1325,  1329,  1333,
    1334,  1335,  1336,  1337,  1338,  1339,  1340,  1341,  1345,  1352,
    1361,  1362,  1363,  1364,  1370,  1371,  1372,  1373,  1381,  1382,
    1383,  1384,  1385,  1386,  1387,  1388,  1389,  1390,  1391,  1392,
    1393,  1394,  1404,  1412,  1422,  1430,  1436,  1453,  1462,  1467,
    1477,  1490,  1492,  1497,  1505,  1506,  1509,  1510,  1514,  1515,
    1516,  1517,  1518,  1519,  1520,  1522,  1523,  1524,  1525,  1526,
    1527,  1528,  1531,  1532,  1533,  1534,  1535,  1543,  1544,  1545,
    1546,  1547,  1551,  1553,  1554,  1559,  1562
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "WHO", "FORMAT",
  "STRCAT", "GTGT", "GT", "LT", "GE", "LE", "EQ", "NE", "PLUS", "MINUS",
  "TIMES", "DIVIDE", "COLONEQUAL", "POW", "UMINUS", "UPLUS", "SIN", "COS",
  "ASIN", "ACOS", "TAN", "ATAN2", "SQRT", "FLOOR", "CEIL", "ABS",
  "RBRACKET", "LBRACKET", "FLOAT", "STRING", "SYMBOL", "BLOCK", "SHOW",
  "PLOT", "EVAL", "INCLUDE", "PRINT", "SAVE", "LOAD", "COPY", "STATS",
  "CENTROID", "VARIANCE", "MAXIMUM", "REFERENCE", "MAP_COMPOSE",
  "MAP_TRANSLATE", "MAP_ROTATE", "MAP_KICKL", "MAP_IDENTITY",
  "MAP_HYPERBOLIC", "MAP_CAVITY", "MAP_DRIFTL", "MAP_CHICANEC",
  "MAP_SPACECHARGE", "MAP_CSR", "MAP_ANALYTIC", "MAP_DRIFTPOLY",
  "MAP_KICKPOLY", "MAP_DRIFTSINE", "MAP_KICKSINE", "MAP_POISSON",
  "MAP_POISSON1D", "PSD_ANALYTIC", "PSD_GAUSS", "PSD_ENSEMBLE",
  "PSD_RECTANGLE", "PSD_TEST", "PSD_BUMP", "PROPAGATE", "MULTIPLY",
  "MODIFY", "NOISE", "NORMALIZE", "WRITE_PROJECTION", "WRITE_LOCALMOMENTS",
  "WRITE_GRID", "WRITE_ENSEMBLE", "INTEGRAL", "CHARGE", "DO", "FOR", "IN",
  "IF", "ELSE", "DEFINED", "MKDIR", "CHDIR", "GETCWD", "GETENV", "STRTOD",
  "STRCMP", "BASENAME", "LINSPACE", "AVERAGE", "TRANSFER4D", "CHICANECOEF",
  "ACCEPT", "';'", "'('", "')'", "','", "'='", "$accept", "input",
  "command", "psd_call", "map_call", "assignment", "var_flt", "var_str",
  "var_psd", "var_map", "var", "string", "array", "vars_flt", "vars",
  "vars_map", "exp", "kwarg", "kwargs", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-320)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-123)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -320,   527,  -320,   -93,   -65,   -63,   628,   628,   -59,   -57,
     -37,   -23,   -13,   -10,    10,    23,    27,    29,   628,  -320,
    -320,   -15,    -2,    34,    43,    49,    57,    59,    98,    99,
     100,   102,   104,   105,   124,   125,   126,   127,   128,   129,
     130,   131,   135,   136,   137,   138,   142,   144,   145,   146,
     158,   159,   164,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   178,   179,   182,   183,   186,   189,   190,   191,
     193,   195,    15,   196,   198,   199,   201,   202,   203,   207,
     208,   209,   210,   211,   212,  -320,   628,  -320,  -320,  -320,
      17,  1476,    96,  -320,  -320,  -320,   213,   628,   628,  -320,
    -320,   297,  -320,   297,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,  1476,   -28,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   226,   628,   298,
     628,   298,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   298,   628,   628,   298,   298,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   120,
     628,   299,   628,   628,   227,   628,   628,   628,   628,   628,
     628,   628,   892,  -320,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,  -320,   232,   234,     7,   239,
     903,   918,   929,   944,   955,     5,   970,  1001,  1027,  1053,
    -320,   628,   243,   245,   247,   248,   298,     3,   246,   249,
     250,   -99,   -96,   251,   254,   255,   256,   257,   258,   259,
     260,  -320,    11,   -62,  1068,  1079,  1104,  -320,  1115,   273,
    -320,   -53,  1130,   -49,   298,   298,   276,  1156,  1167,    16,
      50,   277,   298,   298,   -22,   298,  1440,   -20,   -18,   278,
     279,   280,   281,   261,   282,   283,   284,   285,   -16,   288,
    1182,   628,  1213,   289,   300,   303,  -320,   304,   305,   307,
      61,   312,   363,   388,  -320,  1487,  1487,  1487,  1487,  1487,
     103,   103,     4,     4,   297,  1451,  -320,   628,   628,  -320,
    -320,  -320,  -320,  -320,   628,  -320,  -320,  -320,  -320,  1476,
    -320,  -320,    -9,   628,   253,   311,   313,   628,   628,  -320,
    -320,   314,  -320,  -320,  -320,  -320,  -320,   628,  -320,  -320,
    -320,  -320,   628,  -320,   298,  -320,  -320,    18,    20,   628,
    -320,  -320,   628,   628,   628,    31,    40,  -320,    44,    52,
    -320,  -320,   628,   628,   628,   628,   316,   628,   628,   628,
     628,  -320,   628,  -320,   317,   477,   379,  -320,   319,   322,
    -320,  -320,   628,   628,   628,   628,   628,  -320,    54,   323,
    1228,   324,   298,  -320,  -320,  -320,    60,   327,  -320,  -320,
      63,  -320,  -320,  -320,   329,   725,   736,   298,  -320,  -320,
    -320,  -320,   298,  1239,   330,  1440,  -320,   331,   333,   298,
     298,   339,   326,   342,   -54,  -320,  -320,   344,   751,   762,
     777,   788,  -320,  -320,  -320,  -320,    65,   347,  -320,   628,
     628,    71,    84,   352,   354,    88,   628,   628,    90,    92,
    -320,  -320,  -320,   400,  -320,  -320,   628,   628,   628,   628,
     355,  -320,  1265,  1280,  -320,  -320,  -320,  -320,   356,  1440,
    1291,   357,   358,   359,  1316,   803,   814,   840,  -320,  -320,
    -320,  -320,    95,   360,  -320,  -320,  -320,  -320,   628,   628,
     628,   362,  -320,  1327,   866,  1342,  -320,  -320,   628,  -320,
    1368,  -320
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    64,
      65,    67,    66,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     5,     0,     3,    71,    72,
       0,     0,    60,    70,    73,    69,     0,     0,     0,    67,
      66,   102,    60,   101,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    92,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   123,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   123,     0,     0,   123,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     4,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     6,     0,     0,    60,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      91,     0,    60,    60,     0,     0,   123,    60,     0,     0,
       0,    60,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    96,    60,     0,     0,     0,     0,    57,     0,     0,
     124,     0,     0,     0,   123,   123,     0,     0,     0,     0,
       0,     0,   123,   123,     0,   123,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    88,     0,     0,     0,
       0,     0,     0,     0,    98,   117,   119,   118,   120,   121,
      99,   100,   103,   105,   104,     0,    17,     0,     0,   106,
     107,   108,   109,   110,     0,   112,   113,   114,   115,    93,
       8,     7,     0,     0,     0,     0,     0,     0,     0,    38,
      39,     0,    77,    78,    79,    80,    55,     0,    40,    41,
      42,    44,     0,    49,   126,    43,    50,     0,     0,     0,
      46,    45,     0,     0,     0,     0,     0,    32,     0,     0,
      35,    36,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    74,     0,    76,     0,     0,     0,    68,     0,     0,
      89,    90,     0,     0,     0,     0,     0,   116,     0,     0,
       0,     0,   123,    15,    16,    28,    60,     0,    27,    97,
      60,   125,    51,    52,     0,     0,     0,   123,    54,    31,
      33,    34,   123,     0,     0,   123,    25,     0,     0,   123,
     123,     0,     0,     0,     0,    29,    30,     0,     0,     0,
       0,     0,    86,    87,   111,    13,     0,     0,    56,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      75,     9,    10,     0,    11,    85,     0,     0,     0,     0,
       0,    26,     0,     0,    53,    37,    22,    23,     0,   123,
       0,     0,     0,     0,     0,     0,     0,     0,    14,    48,
      47,    24,     0,     0,    20,    21,    12,    81,     0,     0,
       0,     0,    19,     0,     0,     0,    18,    84,     0,    82,
       0,    83
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -320,  -320,  -320,  -320,  -320,  -320,    -6,   166,  1276,  -319,
      94,  -320,  -320,   150,  -320,  -320,  -320,   133,  -101
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     1,    87,    88,    89,    90,    91,   197,   216,   231,
     102,    93,    94,   115,   222,   233,    95,   240,   241
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     101,   103,   116,   210,   118,   119,   -94,   -94,   389,   316,
     317,    96,   114,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   193,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   402,   193,   443,   194,   194,   -62,    97,
     243,    98,   -61,   326,   327,   104,   -63,   105,   194,   444,
     169,   254,   333,   334,   257,   258,   336,   334,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   106,   193,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   211,   193,
     182,   107,   194,   347,   334,   350,   334,   351,   334,   361,
     362,   108,   117,   194,   109,    92,   381,   334,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   -62,   -62,
     -61,   304,   -61,   -61,   110,   312,   -63,   -63,   191,   192,
     183,   193,   342,   392,   334,   393,   334,   111,   234,   235,
     236,   112,   238,   113,   242,   194,   398,   334,   120,   247,
     248,   249,   250,   337,   338,   399,   334,   121,   256,   400,
     334,   345,   346,   122,   348,   349,   343,   401,   334,   422,
     211,   123,   270,   124,   272,   -95,   -95,   373,  -122,  -122,
     450,   334,   280,   281,   282,   283,   454,   334,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   455,
     334,   198,   198,   458,   334,   461,   334,   462,   334,   195,
     481,   334,   125,   126,   127,   309,   128,   271,   129,   130,
     212,   213,   198,   198,   217,   217,   198,   198,   221,   217,
     198,   217,   217,   217,   217,   217,   217,   232,   131,   132,
     133,   134,   135,   136,   137,   138,   217,   217,   198,   139,
     140,   141,   142,   217,   217,   198,   143,   198,   144,   145,
     146,   217,   217,   217,   217,   217,   217,   217,   217,   217,
     217,   217,   147,   148,   199,   365,   198,   198,   149,   198,
     198,   198,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   426,   159,   160,   214,   215,   161,   162,   219,   220,
     163,   114,   224,   164,   165,   166,   431,   167,   380,   168,
     170,   432,   171,   172,   435,   173,   174,   175,   438,   439,
     246,   176,   177,   178,   179,   180,   181,   253,   196,   255,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   194,
     193,   237,   276,   239,   273,   296,   395,   396,   274,   275,
     297,   277,   278,   279,   194,   298,   -59,   403,   -58,   405,
     310,   311,   313,   412,   314,   315,   383,   318,   472,   319,
     320,   321,   322,   323,   324,   325,   356,   418,   419,   420,
     421,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     332,   193,   339,   344,   352,   353,   354,   355,   357,   358,
     359,   360,   198,   363,   367,   194,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   368,   193,   198,   369,   370,
     371,   386,   198,   372,   384,   414,   385,   388,   374,   406,
     194,   232,   415,   452,   453,   416,   390,   425,   423,   441,
     459,   460,   427,   198,   428,   434,   463,   436,   198,   437,
     464,   465,   466,   467,   440,   442,   232,   378,   198,   445,
     451,   198,   198,   198,   198,   456,   198,   457,   468,   471,
     474,   475,   476,   482,   379,   486,   198,   391,     0,   375,
       0,     0,   483,   484,   485,     0,     0,     0,     0,   382,
       0,     0,   490,     0,   387,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   376,   193,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   394,     0,     0,     0,   194,
     397,     0,     0,   413,     0,     0,     0,     0,     0,     0,
     404,     0,     0,   407,   408,   409,   410,     2,   411,     0,
       3,     4,     5,     0,     0,     0,     0,     0,   417,     0,
       6,     7,     0,     0,     0,     0,     0,     0,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,     0,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,     0,    73,     0,    74,    75,    76,
      77,    78,    79,    80,     0,    81,    82,    83,    84,    85,
       0,    86,     4,     5,     0,     0,     0,     0,     0,     0,
       0,     6,     7,     0,     0,     0,     0,     0,     0,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,     0,
      18,    19,    20,    99,   100,     0,     0,     0,     0,     0,
       0,    29,    30,     0,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,     0,     0,     0,     0,     0,     0,     0,
       0,    69,    70,     0,     0,     0,     0,     0,    74,     0,
       0,    77,    78,    79,    80,     0,    81,    82,    83,    84,
       0,     0,    86,   184,   185,   186,   187,   188,   189,   190,
     191,   192,     0,   193,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   193,     0,     0,   194,     0,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   194,   193,
     184,   185,   186,   187,   188,   189,   190,   191,   192,     0,
     193,     0,     0,   194,     0,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   194,   193,   184,   185,   186,   187,
     188,   189,   190,   191,   192,     0,   193,     0,     0,   194,
       0,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     194,   193,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   429,   193,     0,     0,   194,     0,     0,     0,     0,
       0,     0,   430,     0,     0,     0,   194,     0,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   446,   193,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   447,     0,
       0,     0,   194,     0,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   448,   193,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   449,     0,     0,     0,   194,     0,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   478,
     193,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     479,   193,     0,     0,   194,     0,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   194,   193,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   480,   193,     0,     0,
     194,     0,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   194,   193,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   488,   193,     0,     0,   194,     0,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   194,   193,     0,
       0,     0,     0,     0,     0,     0,     0,   284,     0,     0,
       0,     0,   194,     0,     0,     0,     0,     0,   299,   184,
     185,   186,   187,   188,   189,   190,   191,   192,     0,   193,
       0,     0,     0,   300,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   194,   301,   184,   185,   186,   187,   188,
     189,   190,   191,   192,     0,   193,     0,     0,     0,   302,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194,
     303,   184,   185,   186,   187,   188,   189,   190,   191,   192,
       0,   193,     0,     0,     0,   305,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   194,   193,   184,   185,   186,
     187,   188,   189,   190,   191,   192,     0,   193,     0,     0,
     194,     0,     0,     0,     0,     0,   306,     0,     0,     0,
       0,   194,   184,   185,   186,   187,   188,   189,   190,   191,
     192,     0,   193,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   307,   193,     0,     0,   194,     0,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   194,   193,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   308,     0,
       0,     0,   194,     0,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   328,   193,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   329,   193,     0,     0,   194,     0,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   194,
     193,     0,     0,     0,     0,     0,     0,     0,     0,   330,
       0,     0,     0,     0,   194,     0,     0,     0,     0,     0,
     331,   184,   185,   186,   187,   188,   189,   190,   191,   192,
       0,   193,     0,     0,     0,   335,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   194,   193,   184,   185,   186,
     187,   188,   189,   190,   191,   192,     0,   193,     0,     0,
     194,   340,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   194,   341,   184,   185,   186,   187,   188,   189,   190,
     191,   192,     0,   193,     0,     0,     0,   364,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   194,   193,   184,
     185,   186,   187,   188,   189,   190,   191,   192,     0,   193,
       0,     0,   194,     0,     0,     0,     0,     0,   366,     0,
       0,     0,     0,   194,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   424,   193,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   433,   193,     0,     0,   194,     0,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   194,
     193,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     469,     0,     0,     0,   194,     0,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   470,   193,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   473,   218,     0,     0,
     194,   223,     0,   225,   226,   227,   228,   229,   230,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   244,   245,
       0,   477,     0,     0,     0,   251,   252,     0,     0,     0,
       0,     0,   487,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,     0,     0,     0,   489,   184,   185,
     186,   187,   188,   189,   190,   191,   192,     0,   193,   184,
     185,   186,   187,   188,   189,   190,   191,   192,     0,   193,
       0,     0,   194,   491,     0,   239,     0,     0,     0,     0,
       0,     0,   377,   194,   184,   185,   186,   187,   188,   189,
     190,   191,   192,     0,   193,  -123,  -123,  -123,  -123,  -123,
     189,   190,   191,   192,     0,   193,     0,     0,   194,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194
};

static const yytype_int16 yycheck[] =
{
       6,     7,    17,    31,     6,     7,   105,   106,   327,   105,
     106,   104,    18,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    18,    18,     8,     9,    10,    11,    12,    13,
      14,    15,    16,   352,    18,    89,    32,    32,    35,   104,
     141,   104,    35,   105,   106,   104,    35,   104,    32,   103,
      35,   152,   105,   106,   155,   156,   105,   106,     8,     9,
      10,    11,    12,    13,    14,    15,    16,   104,    18,     8,
       9,    10,    11,    12,    13,    14,    15,    16,   106,    18,
      86,   104,    32,   105,   106,   105,   106,   105,   106,   105,
     106,   104,   107,    32,   104,     1,   105,   106,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   105,   106,
     103,   106,   105,   106,   104,   216,   105,   106,    15,    16,
     103,    18,   106,   105,   106,   105,   106,   104,   134,   135,
     136,   104,   138,   104,   140,    32,   105,   106,   104,   145,
     146,   147,   148,   244,   245,   105,   106,   104,   154,   105,
     106,   252,   253,   104,   255,   256,   106,   105,   106,   105,
     106,   104,   168,   104,   170,   105,   106,   106,   105,   106,
     105,   106,   178,   179,   180,   181,   105,   106,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   105,
     106,    97,    98,   105,   106,   105,   106,   105,   106,   103,
     105,   106,   104,   104,   104,   211,   104,    87,   104,   104,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   104,   104,
     104,   104,   104,   104,   104,   104,   142,   143,   144,   104,
     104,   104,   104,   149,   150,   151,   104,   153,   104,   104,
     104,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   104,   104,    98,   271,   172,   173,   104,   175,
     176,   177,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   382,   104,   104,   118,   119,   104,   104,   122,   123,
     104,   297,   126,   104,   104,   104,   397,   104,   304,   104,
     104,   402,   104,   104,   405,   104,   104,   104,   409,   410,
     144,   104,   104,   104,   104,   104,   104,   151,   105,   153,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    32,
      18,   105,   105,    35,    35,   103,   342,   343,   172,   173,
     106,   175,   176,   177,    32,   106,   103,   353,   103,   355,
     103,   103,   106,    36,   105,   105,   103,   106,   459,   105,
     105,   105,   105,   105,   105,   105,   105,   373,   374,   375,
     376,     8,     9,    10,    11,    12,    13,    14,    15,    16,
     107,    18,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   298,   105,   105,    32,     8,     9,    10,    11,
      12,    13,    14,    15,    16,   105,    18,   313,   105,   105,
     105,   317,   318,   106,   103,    36,   103,   103,   106,   103,
      32,   327,   103,   429,   430,   103,   332,   103,   105,   103,
     436,   437,   105,   339,   105,   105,    36,   106,   344,   106,
     446,   447,   448,   449,   105,   103,   352,   297,   354,   105,
     103,   357,   358,   359,   360,   103,   362,   103,   103,   103,
     103,   103,   103,   103,   298,   103,   372,   334,    -1,   106,
      -1,    -1,   478,   479,   480,    -1,    -1,    -1,    -1,   313,
      -1,    -1,   488,    -1,   318,     8,     9,    10,    11,    12,
      13,    14,    15,    16,   106,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,    32,
     344,    -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,
     354,    -1,    -1,   357,   358,   359,   360,     0,   362,    -1,
       3,     4,     5,    -1,    -1,    -1,    -1,    -1,   372,    -1,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    -1,    88,    -1,    90,    91,    92,
      93,    94,    95,    96,    -1,    98,    99,   100,   101,   102,
      -1,   104,     4,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    44,    -1,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    83,    84,    -1,    -1,    -1,    -1,    -1,    90,    -1,
      -1,    93,    94,    95,    96,    -1,    98,    99,   100,   101,
      -1,    -1,   104,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    18,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    18,    -1,    -1,    32,    -1,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    32,    18,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    -1,
      18,    -1,    -1,    32,    -1,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    32,    18,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    -1,    18,    -1,    -1,    32,
      -1,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      32,    18,     8,     9,    10,    11,    12,    13,    14,    15,
      16,   106,    18,    -1,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,   106,    -1,    -1,    -1,    32,    -1,     8,     9,
      10,    11,    12,    13,    14,    15,    16,   106,    18,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   106,    -1,
      -1,    -1,    32,    -1,     8,     9,    10,    11,    12,    13,
      14,    15,    16,   106,    18,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    32,    -1,
       8,     9,    10,    11,    12,    13,    14,    15,    16,   106,
      18,     8,     9,    10,    11,    12,    13,    14,    15,    16,
     106,    18,    -1,    -1,    32,    -1,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    32,    18,     8,     9,    10,
      11,    12,    13,    14,    15,    16,   106,    18,    -1,    -1,
      32,    -1,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    32,    18,     8,     9,    10,    11,    12,    13,    14,
      15,    16,   106,    18,    -1,    -1,    32,    -1,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    32,    18,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,   105,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    -1,    18,
      -1,    -1,    -1,   105,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,   105,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    -1,    18,    -1,    -1,    -1,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
     105,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    18,    -1,    -1,    -1,   105,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    32,    18,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    -1,    18,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,   105,    -1,    -1,    -1,
      -1,    32,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    -1,    18,     8,     9,    10,    11,    12,    13,    14,
      15,    16,   105,    18,    -1,    -1,    32,    -1,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    32,    18,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,    -1,
      -1,    -1,    32,    -1,     8,     9,    10,    11,    12,    13,
      14,    15,    16,   105,    18,     8,     9,    10,    11,    12,
      13,    14,    15,    16,   105,    18,    -1,    -1,    32,    -1,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    32,
      18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
      -1,    -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,
     105,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      -1,    18,    -1,    -1,    -1,   105,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    32,    18,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    -1,    18,    -1,    -1,
      32,   105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    32,   105,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    18,    -1,    -1,    -1,   105,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    32,    18,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    -1,    18,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,   105,    -1,
      -1,    -1,    -1,    32,     8,     9,    10,    11,    12,    13,
      14,    15,    16,   105,    18,     8,     9,    10,    11,    12,
      13,    14,    15,    16,   105,    18,    -1,    -1,    32,    -1,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    32,
      18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,    -1,    -1,    -1,    32,    -1,     8,     9,    10,    11,
      12,    13,    14,    15,    16,   105,    18,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,   121,    -1,    -1,
      32,   125,    -1,   127,   128,   129,   130,   131,   132,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   142,   143,
      -1,   105,    -1,    -1,    -1,   149,   150,    -1,    -1,    -1,
      -1,    -1,   105,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,    -1,    -1,    -1,   105,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    -1,    18,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    -1,    18,
      -1,    -1,    32,   105,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    31,    32,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    -1,    18,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    -1,    18,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,   109,     0,     3,     4,     5,    13,    14,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    88,    90,    91,    92,    93,    94,    95,
      96,    98,    99,   100,   101,   102,   104,   110,   111,   112,
     113,   114,   118,   119,   120,   124,   104,   104,   104,    35,
      36,   114,   118,   114,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   114,   121,    17,   107,     6,     7,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   104,   104,   104,   104,   104,   104,   104,    35,
     104,   104,   104,   104,   104,   104,   104,   104,   104,   104,
     104,   104,   114,   103,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    18,    32,   103,   105,   115,   118,   115,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
      31,   106,   118,   118,   115,   115,   116,   118,   116,   115,
     115,   118,   122,   116,   115,   116,   116,   116,   116,   116,
     116,   117,   118,   123,   114,   114,   114,   105,   114,    35,
     125,   126,   114,   126,   116,   116,   115,   114,   114,   114,
     114,   116,   116,   115,   126,   115,   114,   126,   126,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     114,    87,   114,    35,   115,   115,   105,   115,   115,   115,
     114,   114,   114,   114,   105,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   103,   106,   106,   105,
     105,   105,   105,   105,   106,   105,   105,   105,   105,   114,
     103,   103,   126,   106,   105,   105,   105,   106,   106,   105,
     105,   105,   105,   105,   105,   105,   105,   106,   105,   105,
     105,   105,   107,   105,   106,   105,   105,   126,   126,   106,
     105,   105,   106,   106,   106,   126,   126,   105,   126,   126,
     105,   105,   106,   106,   106,   106,   105,   106,   106,   106,
     106,   105,   106,   105,   105,   114,   105,   105,   105,   105,
     105,   105,   106,   106,   106,   106,   106,    31,   121,   115,
     114,   105,   115,   103,   103,   103,   118,   115,   103,   117,
     118,   125,   105,   105,   115,   114,   114,   115,   105,   105,
     105,   105,   117,   114,   115,   114,   103,   115,   115,   115,
     115,   115,    36,    36,    36,   103,   103,   115,   114,   114,
     114,   114,   105,   105,   105,   103,   126,   105,   105,   106,
     106,   126,   126,   105,   105,   126,   106,   106,   126,   126,
     105,   103,   103,    89,   103,   105,   106,   106,   106,   106,
     105,   103,   114,   114,   105,   105,   103,   103,   105,   114,
     114,   105,   105,    36,   114,   114,   114,   114,   103,   105,
     105,   103,   126,   105,   103,   103,   103,   105,   106,   106,
     106,   105,   103,   114,   114,   114,   103,   105,   106,   105,
     114,   105
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,   108,   109,   109,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   111,   111,   111,   111,   111,   111,   111,   111,   111,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   113,   113,
     114,   115,   116,   117,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   119,   119,   119,   119,
     119,   120,   121,   121,   122,   122,   123,   123,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   125,   126,   126,   126,   126
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     1,     2,     4,     4,     6,
       6,     6,     8,     6,     8,     5,     5,     4,    10,     9,
       8,     8,     7,     7,     8,     5,     7,     5,     5,     5,
       5,     5,     4,     5,     5,     4,     4,     7,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     8,     8,     4,
       4,     5,     5,     7,     5,     4,     6,     3,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       1,     1,     1,     1,     4,     6,     4,     4,     4,     4,
       4,     8,    10,    12,    10,     6,     6,     6,     3,     4,
       4,     3,     1,     3,     1,     3,     1,     3,     3,     3,
       3,     2,     2,     3,     3,     3,     4,     4,     4,     4,
       4,     6,     4,     4,     4,     4,     4,     3,     3,     3,
       3,     3,     3,     0,     1,     3,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 5: /* command: ACCEPT  */
#line 1118 "src/selav1d/main.y"
                 { YYACCEPT; }
#line 2731 "src/selav1d/main.tab.c"
    break;

  case 6: /* command: var ';'  */
#line 1120 "src/selav1d/main.y"
                  { (yyvsp[-1].varval)->print(OUTFILE); fprintf(OUTFILE,"\n");  (yyvsp[-1].varval)->unref(); }
#line 2737 "src/selav1d/main.tab.c"
    break;

  case 7: /* command: BLOCK GT var_str ';'  */
#line 1122 "src/selav1d/main.y"
                               { // >
		FILE* fd = fopen((yyvsp[-1].varval)->sval,"w");
		if(fd==NULL) { print_buffer_position(); perror((yyvsp[-1].varval)->sval); exit(1); };
		fdstack_push(fd);
		parse_string__((yyvsp[-3].sval));
		fdstack_pop();
		free((yyvsp[-3].sval));
		(yyvsp[-1].varval)->unref();
	}
#line 2751 "src/selav1d/main.tab.c"
    break;

  case 8: /* command: BLOCK GTGT var_str ';'  */
#line 1131 "src/selav1d/main.y"
                                 { // >>
		FILE* fd = fopen((yyvsp[-1].varval)->sval,"a");
		if(fd==NULL) { print_buffer_position(); perror((yyvsp[-1].varval)->sval); exit(1); };
		fdstack_push(fd);
		parse_string__((yyvsp[-3].sval));
		fdstack_pop();
		free((yyvsp[-3].sval));
		(yyvsp[-1].varval)->unref();
	}
#line 2765 "src/selav1d/main.tab.c"
    break;

  case 9: /* command: DO '(' var_flt ')' BLOCK ';'  */
#line 1140 "src/selav1d/main.y"
                                       {
		for(int n=0; n<floor((yyvsp[-3].varval)->fval[0]); n++) {
			parse_string__((yyvsp[-1].sval));
		}
	}
#line 2775 "src/selav1d/main.tab.c"
    break;

  case 10: /* command: FOR SYMBOL IN var_flt BLOCK ';'  */
#line 1145 "src/selav1d/main.y"
                                          {
		if(ENV.count((yyvsp[-4].sval))!=0) { /* Variable exists */
			ENV[(yyvsp[-4].sval)]->unref();
		}
		ENV[(yyvsp[-4].sval)] = new var(0.0,1);
		for(size_t n=0; n<(yyvsp[-2].varval)->size; n++) {
			ENV[(yyvsp[-4].sval)]->fval[0] = (yyvsp[-2].varval)->fval[n];
			parse_string__((yyvsp[-1].sval));
		}
		free((yyvsp[-4].sval));
		free((yyvsp[-1].sval));
		(yyvsp[-2].varval)->unref();
	}
#line 2793 "src/selav1d/main.tab.c"
    break;

  case 11: /* command: IF '(' var_flt ')' BLOCK ';'  */
#line 1158 "src/selav1d/main.y"
                                       { if((yyvsp[-3].varval)->fval[0]>0) parse_string__((yyvsp[-1].sval)); }
#line 2799 "src/selav1d/main.tab.c"
    break;

  case 12: /* command: IF '(' var_flt ')' BLOCK ELSE BLOCK ';'  */
#line 1159 "src/selav1d/main.y"
                                                  { if((yyvsp[-5].varval)->fval[0]>0) parse_string__((yyvsp[-3].sval)); else parse_string__((yyvsp[-1].sval));}
#line 2805 "src/selav1d/main.tab.c"
    break;

  case 13: /* command: SHOW '(' var_psd kwargs ')' ';'  */
#line 1160 "src/selav1d/main.y"
                                             { show__((yyvsp[-3].varval)->psdval,(yyvsp[-2].envval)); (yyvsp[-3].varval)->unref(); delete (yyvsp[-2].envval); }
#line 2811 "src/selav1d/main.tab.c"
    break;

  case 14: /* command: PLOT '(' var_psd ',' var_str kwargs ')' ';'  */
#line 1161 "src/selav1d/main.y"
                                                         { plot__((yyvsp[-5].varval)->psdval,(yyvsp[-3].varval)->sval,(yyvsp[-2].envval)); (yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref(); delete (yyvsp[-2].envval); }
#line 2817 "src/selav1d/main.tab.c"
    break;

  case 15: /* command: EVAL '(' var_str ')' ';'  */
#line 1162 "src/selav1d/main.y"
                                      { parse_string__((yyvsp[-2].varval)->sval); (yyvsp[-2].varval)->unref(); }
#line 2823 "src/selav1d/main.tab.c"
    break;

  case 16: /* command: INCLUDE '(' var_str ')' ';'  */
#line 1163 "src/selav1d/main.y"
                                      { parse_file__((yyvsp[-2].varval)->sval); (yyvsp[-2].varval)->unref(); }
#line 2829 "src/selav1d/main.tab.c"
    break;

  case 17: /* command: WHO '(' ')' ';'  */
#line 1164 "src/selav1d/main.y"
                          {
		for(auto v : ENV) {
			switch(v.second->type) {
			case(STR):
				//fprintf(OUTFILE,"%s (STR) = ", v.first.c_str());
				fprintf(OUTFILE,"%s = ", v.first.c_str());
				break;
			case(FLT):
				//fprintf(OUTFILE,"%s (FLT[%ld]) = ", v.first.c_str(),v.second->size);
				fprintf(OUTFILE,"%s = ", v.first.c_str());
				break;
			case(MAP):
				//fprintf(OUTFILE,"%s (MAP)",    v.first.c_str());
				fprintf(OUTFILE,"%s ",    v.first.c_str());
				break;
			case(PSD):
				//fprintf(OUTFILE,"%s (PSD) = ", v.first.c_str());
				fprintf(OUTFILE,"%s = ", v.first.c_str());
				break;
			}
			v.second->print(OUTFILE);
			fprintf(OUTFILE,";\n");
		}
	}
#line 2858 "src/selav1d/main.tab.c"
    break;

  case 18: /* command: WRITE_PROJECTION '(' var_psd ',' var_str ',' var_flt kwargs ')' ';'  */
#line 1188 "src/selav1d/main.y"
                                                                              {
		write_projection__((yyvsp[-7].varval)->psdval,(yyvsp[-5].varval)->sval,*((yyvsp[-3].varval)->fval),(yyvsp[-2].envval));
		(yyvsp[-7].varval)->unref(); (yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref();
		delete (yyvsp[-2].envval);
	}
#line 2868 "src/selav1d/main.tab.c"
    break;

  case 19: /* command: WRITE_LOCALMOMENTS '(' var_psd ',' var_str ',' var_flt ')' ';'  */
#line 1193 "src/selav1d/main.y"
                                                                         {
		write_localmoments__((yyvsp[-6].varval)->psdval,(yyvsp[-4].varval)->sval,*((yyvsp[-2].varval)->fval));
		(yyvsp[-6].varval)->unref(); (yyvsp[-4].varval)->unref(); (yyvsp[-2].varval)->unref();
	}
#line 2877 "src/selav1d/main.tab.c"
    break;

  case 20: /* command: WRITE_GRID '(' var_psd ',' var_str kwargs ')' ';'  */
#line 1197 "src/selav1d/main.y"
                                                            {
		write_grid__((yyvsp[-5].varval)->psdval,(yyvsp[-3].varval)->sval,(yyvsp[-2].envval));
		(yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref();
		delete (yyvsp[-2].envval);
	}
#line 2887 "src/selav1d/main.tab.c"
    break;

  case 21: /* command: WRITE_ENSEMBLE '(' var_psd ',' var_str kwargs ')' ';'  */
#line 1202 "src/selav1d/main.y"
                                                                 {
		write_ensemble__((yyvsp[-5].varval)->psdval, (yyvsp[-3].varval)->sval, (yyvsp[-2].envval));
		(yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref();
		delete (yyvsp[-2].envval);
	}
#line 2897 "src/selav1d/main.tab.c"
    break;

  case 22: /* command: MULTIPLY '(' var_psd ',' var_flt ')' ';'  */
#line 1207 "src/selav1d/main.y"
                                                  {
		(yyvsp[-4].varval)->psdval->multiply((yyvsp[-2].varval)->fval[0]);
		(yyvsp[-4].varval)->unref(); (yyvsp[-2].varval)->unref();
	}
#line 2906 "src/selav1d/main.tab.c"
    break;

  case 23: /* command: MODIFY '(' var_psd ',' var_str ')' ';'  */
#line 1211 "src/selav1d/main.y"
                                                {
		modify__((yyvsp[-4].varval)->psdval, (yyvsp[-2].varval)->sval);
		(yyvsp[-4].varval)->unref(); (yyvsp[-2].varval)->unref();
	}
#line 2915 "src/selav1d/main.tab.c"
    break;

  case 24: /* command: NOISE '(' var_psd ',' var_flt kwargs ')' ';'  */
#line 1215 "src/selav1d/main.y"
                                                      {
		noise__((yyvsp[-5].varval)->psdval, (yyvsp[-3].varval)->fval[0], (yyvsp[-2].envval));
		(yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref();
		delete (yyvsp[-2].envval);
	}
#line 2925 "src/selav1d/main.tab.c"
    break;

  case 25: /* command: NORMALIZE '(' var_psd ')' ';'  */
#line 1220 "src/selav1d/main.y"
                                        {
		(yyvsp[-2].varval)->psdval->normalize();
		(yyvsp[-2].varval)->unref();
	}
#line 2934 "src/selav1d/main.tab.c"
    break;

  case 26: /* command: SAVE '(' var_psd ',' var_str ')' ';'  */
#line 1224 "src/selav1d/main.y"
                                               {
		const char* fname = (yyvsp[-2].varval)->sval;
		FILE* fd = fopen(fname,"w");
		if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); };
		SLV::save((yyvsp[-4].varval)->psdval,fd);
		fclose(fd);
		(yyvsp[-4].varval)->unref(); (yyvsp[-2].varval)->unref();
	}
#line 2947 "src/selav1d/main.tab.c"
    break;

  case 27: /* command: STATS '(' var_psd ')' ';'  */
#line 1232 "src/selav1d/main.y"
                                    {
		SLV::psd_stats((yyvsp[-2].varval)->psdval,OUTFILE);
		(yyvsp[-2].varval)->unref();
	}
#line 2956 "src/selav1d/main.tab.c"
    break;

  case 28: /* command: PRINT '(' vars ')' ';'  */
#line 1236 "src/selav1d/main.y"
                                    {
		for(auto v : *(yyvsp[-2].varvals)) {
			if(v->type==STR) {
				fprintf(OUTFILE,"%s",v->sval);
			}
			else if(v->type==FLT) {
				for(size_t i=0; i<v->size; i++) {
					fprintf(OUTFILE,"%.16e",v->fval[i]);
					if(i<v->size-1) fprintf(OUTFILE," ");
				}
			} else {
				v->print(OUTFILE);
			}
			if(v != (yyvsp[-2].varvals)->back()) {
				fprintf(OUTFILE," ");
			}
			v->unref();
		}
		fprintf(OUTFILE,"\n");
		delete (yyvsp[-2].varvals);
	}
#line 2982 "src/selav1d/main.tab.c"
    break;

  case 29: /* command: MKDIR '(' var_str ')' ';'  */
#line 1257 "src/selav1d/main.y"
                                    {
		int status;
		status = mkdir((yyvsp[-2].varval)->sval,0755);
		if(status && errno != EEXIST) { print_buffer_position(); perror((yyvsp[-2].varval)->sval); exit(1); };
		(yyvsp[-2].varval)->unref();
	}
#line 2993 "src/selav1d/main.tab.c"
    break;

  case 30: /* command: CHDIR '(' var_str ')' ';'  */
#line 1263 "src/selav1d/main.y"
                                    {
		int status;
		status = chdir((yyvsp[-2].varval)->sval);
		if(status) { print_buffer_position(); perror((yyvsp[-2].varval)->sval); exit(1); };
		(yyvsp[-2].varval)->unref();
	}
#line 3004 "src/selav1d/main.tab.c"
    break;

  case 31: /* psd_call: PSD_ANALYTIC '(' var_str kwargs ')'  */
#line 1272 "src/selav1d/main.y"
                                              {
		(yyval.varval) = new var(psd_analytic__((yyvsp[-2].varval)->sval,(yyvsp[-1].envval)));
		(yyvsp[-2].varval)->unref(); delete (yyvsp[-1].envval);
		}
#line 3013 "src/selav1d/main.tab.c"
    break;

  case 32: /* psd_call: PSD_GAUSS '(' kwargs ')'  */
#line 1276 "src/selav1d/main.y"
                                   {
		(yyval.varval) = new var(psd_gauss__((yyvsp[-1].envval)));
		delete (yyvsp[-1].envval);
		}
#line 3022 "src/selav1d/main.tab.c"
    break;

  case 33: /* psd_call: PSD_ENSEMBLE '(' var_str kwargs ')'  */
#line 1280 "src/selav1d/main.y"
                                               {
		(yyval.varval) = new var(psd_ensemble__((yyvsp[-2].varval)->sval,(yyvsp[-1].envval)));
		(yyvsp[-2].varval)->unref();
		delete (yyvsp[-1].envval);
		}
#line 3032 "src/selav1d/main.tab.c"
    break;

  case 34: /* psd_call: PSD_RECTANGLE '(' var_flt kwargs ')'  */
#line 1285 "src/selav1d/main.y"
                                                {
		(yyval.varval) = new var(psd_rectangle__((yyvsp[-2].varval)->fval,(yyvsp[-1].envval)));
		//$3->unref();
		delete (yyvsp[-1].envval);
		}
#line 3042 "src/selav1d/main.tab.c"
    break;

  case 35: /* psd_call: PSD_TEST '(' kwargs ')'  */
#line 1290 "src/selav1d/main.y"
                                  {
		(yyval.varval) = new var(psd_test__((yyvsp[-1].envval)));
		delete (yyvsp[-1].envval);
		}
#line 3051 "src/selav1d/main.tab.c"
    break;

  case 36: /* psd_call: PSD_BUMP '(' kwargs ')'  */
#line 1294 "src/selav1d/main.y"
                                  {
		(yyval.varval) = new var(psd_bump__((yyvsp[-1].envval)));
		delete (yyvsp[-1].envval);
		}
#line 3060 "src/selav1d/main.tab.c"
    break;

  case 37: /* psd_call: PROPAGATE '(' var_psd ',' var_map kwargs ')'  */
#line 1298 "src/selav1d/main.y"
                                                       {
		(yyval.varval) = new var(propagate__((yyvsp[-4].varval)->psdval,(yyvsp[-2].varval)->mapval,(yyvsp[-1].envval)));
		(yyvsp[-4].varval)->unref(); (yyvsp[-2].varval)->unref();
		delete (yyvsp[-1].envval);
		}
#line 3070 "src/selav1d/main.tab.c"
    break;

  case 38: /* psd_call: LOAD '(' var_str ')'  */
#line 1303 "src/selav1d/main.y"
                               {
		const char* fname = (yyvsp[-1].varval)->sval;
		FILE* fd = fopen(fname,"r");
		if(fd==NULL) { print_buffer_position(); perror(fname); exit(1); };
		(yyval.varval) = new var(SLV::load<2>(fd));
		fclose(fd);
		(yyvsp[-1].varval)->unref();
		}
#line 3083 "src/selav1d/main.tab.c"
    break;

  case 39: /* psd_call: COPY '(' var_psd ')'  */
#line 1311 "src/selav1d/main.y"
                               {
		(yyval.varval) = new var((yyvsp[-1].varval)->psdval->copy());
		(yyvsp[-1].varval)->unref();
	}
#line 3092 "src/selav1d/main.tab.c"
    break;

  case 40: /* map_call: MAP_TRANSLATE '(' var_flt ')'  */
#line 1318 "src/selav1d/main.y"
                                           { (yyval.varval) = new var(map_translate__((yyvsp[-1].varval)->fval)); (yyvsp[-1].varval)->unref(); }
#line 3098 "src/selav1d/main.tab.c"
    break;

  case 41: /* map_call: MAP_ROTATE '(' var_flt ')'  */
#line 1319 "src/selav1d/main.y"
                                           { (yyval.varval) = new var(map_rotate__((yyvsp[-1].varval)->fval[0])); delete (yyvsp[-1].varval); }
#line 3104 "src/selav1d/main.tab.c"
    break;

  case 42: /* map_call: MAP_KICKL '(' var_flt ')'  */
#line 1320 "src/selav1d/main.y"
                                           { (yyval.varval) = new var(map_kickl__((yyvsp[-1].varval)->fval[0])); (yyvsp[-1].varval)->unref(); }
#line 3110 "src/selav1d/main.tab.c"
    break;

  case 43: /* map_call: MAP_DRIFTL '(' var_flt ')'  */
#line 1321 "src/selav1d/main.y"
                                           { (yyval.varval) = new var(map_driftl__((yyvsp[-1].varval)->fval[0]));(yyvsp[-1].varval)->unref(); }
#line 3116 "src/selav1d/main.tab.c"
    break;

  case 44: /* map_call: MAP_HYPERBOLIC '(' var_flt ')'  */
#line 1322 "src/selav1d/main.y"
                                           { (yyval.varval) = new var(map_hyperbolic__((yyvsp[-1].varval)->fval[0]));(yyvsp[-1].varval)->unref(); }
#line 3122 "src/selav1d/main.tab.c"
    break;

  case 45: /* map_call: MAP_KICKPOLY '(' var_flt ')'  */
#line 1323 "src/selav1d/main.y"
                                           { (yyval.varval) = new var(map_kickpoly__((yyvsp[-1].varval)->size,(yyvsp[-1].varval)->fval)); (yyvsp[-1].varval)->unref(); }
#line 3128 "src/selav1d/main.tab.c"
    break;

  case 46: /* map_call: MAP_DRIFTPOLY '(' var_flt ')'  */
#line 1324 "src/selav1d/main.y"
                                           { (yyval.varval) = new var(map_driftpoly__((yyvsp[-1].varval)->size,(yyvsp[-1].varval)->fval));(yyvsp[-1].varval)->unref(); }
#line 3134 "src/selav1d/main.tab.c"
    break;

  case 47: /* map_call: MAP_KICKSINE '(' var_flt ',' var_flt ',' var_flt ')'  */
#line 1325 "src/selav1d/main.y"
                                                                   {
		(yyval.varval) = new var(map_kicksine__((yyvsp[-5].varval)->fval[0],(yyvsp[-3].varval)->fval[0],(yyvsp[-1].varval)->fval[0]));
		(yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref();
		}
#line 3143 "src/selav1d/main.tab.c"
    break;

  case 48: /* map_call: MAP_DRIFTSINE '(' var_flt ',' var_flt ',' var_flt ')'  */
#line 1329 "src/selav1d/main.y"
                                                                   {
		(yyval.varval) = new var(map_driftsine__((yyvsp[-5].varval)->fval[0],(yyvsp[-3].varval)->fval[0],(yyvsp[-1].varval)->fval[0]));
		(yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref();
		}
#line 3152 "src/selav1d/main.tab.c"
    break;

  case 49: /* map_call: MAP_CAVITY '(' kwargs ')'  */
#line 1333 "src/selav1d/main.y"
                                           { (yyval.varval) = new var(map_cavity__((yyvsp[-1].envval))); delete (yyvsp[-1].envval); }
#line 3158 "src/selav1d/main.tab.c"
    break;

  case 50: /* map_call: MAP_CHICANEC '(' kwargs ')'  */
#line 1334 "src/selav1d/main.y"
                                           { (yyval.varval) = new var(map_chicanec__((yyvsp[-1].envval))); delete (yyvsp[-1].envval); }
#line 3164 "src/selav1d/main.tab.c"
    break;

  case 51: /* map_call: MAP_SPACECHARGE '(' var_psd kwargs ')'  */
#line 1335 "src/selav1d/main.y"
                                                  { (yyval.varval) = new var(map_spacecharge__((yyvsp[-2].varval)->psdval,(yyvsp[-1].envval))); (yyvsp[-2].varval)->unref(); delete (yyvsp[-1].envval); }
#line 3170 "src/selav1d/main.tab.c"
    break;

  case 52: /* map_call: MAP_CSR '(' var_psd kwargs ')'  */
#line 1336 "src/selav1d/main.y"
                                                  { (yyval.varval) = new var(map_csr__((yyvsp[-2].varval)->psdval,(yyvsp[-1].envval))); (yyvsp[-2].varval)->unref(); delete (yyvsp[-1].envval); }
#line 3176 "src/selav1d/main.tab.c"
    break;

  case 53: /* map_call: MAP_POISSON '(' var_psd ',' var_str kwargs ')'  */
#line 1337 "src/selav1d/main.y"
                                                              { (yyval.varval) = new var(map_poisson__((yyvsp[-4].varval)->psdval,(yyvsp[-2].varval)->sval,(yyvsp[-1].envval))); (yyvsp[-4].varval)->unref(); (yyvsp[-2].varval)->unref(); delete (yyvsp[-1].envval); }
#line 3182 "src/selav1d/main.tab.c"
    break;

  case 54: /* map_call: MAP_POISSON1D '(' var_psd kwargs ')'  */
#line 1338 "src/selav1d/main.y"
                                                  { (yyval.varval) = new var(map_poisson1d__((yyvsp[-2].varval)->psdval,(yyvsp[-1].envval))); (yyvsp[-2].varval)->unref(); delete (yyvsp[-1].envval); }
#line 3188 "src/selav1d/main.tab.c"
    break;

  case 55: /* map_call: MAP_COMPOSE '(' vars_map ')'  */
#line 1339 "src/selav1d/main.y"
                                            { (yyval.varval) = new var(map_compose__((yyvsp[-1].varvals))); delete (yyvsp[-1].varvals); }
#line 3194 "src/selav1d/main.tab.c"
    break;

  case 56: /* map_call: MAP_ANALYTIC '(' var_str ',' var_str ')'  */
#line 1340 "src/selav1d/main.y"
                                                       { (yyval.varval) = new var(map_analytic__((yyvsp[-3].varval)->sval,(yyvsp[-1].varval)->sval)); (yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref(); }
#line 3200 "src/selav1d/main.tab.c"
    break;

  case 57: /* map_call: MAP_IDENTITY '(' ')'  */
#line 1341 "src/selav1d/main.y"
                                   { (yyval.varval) = new var(map_identity__()); }
#line 3206 "src/selav1d/main.tab.c"
    break;

  case 58: /* assignment: SYMBOL '=' var  */
#line 1345 "src/selav1d/main.y"
                           {
		if(ENV.count((yyvsp[-2].sval))!=0) { /* Variable exists */
			ENV[(yyvsp[-2].sval)]->unref();
		}
		ENV[(yyvsp[-2].sval)] = (yyvsp[0].varval);
		free((yyvsp[-2].sval));
	}
#line 3218 "src/selav1d/main.tab.c"
    break;

  case 59: /* assignment: SYMBOL COLONEQUAL var  */
#line 1352 "src/selav1d/main.y"
                                { // Default assignment
		if(ENV.count((yyvsp[-2].sval))==0) { /* Variable does not exists */
			ENV[(yyvsp[-2].sval)] = (yyvsp[0].varval);
		}
		free((yyvsp[-2].sval));
	}
#line 3229 "src/selav1d/main.tab.c"
    break;

  case 60: /* var_flt: var  */
#line 1361 "src/selav1d/main.y"
             { if( true != (yyvsp[0].varval)->assert_type(FLT)) { print_buffer_position(); error(1,0,"Error: variable used wrong context\n"); }; }
#line 3235 "src/selav1d/main.tab.c"
    break;

  case 61: /* var_str: var  */
#line 1362 "src/selav1d/main.y"
             { if( true != (yyvsp[0].varval)->assert_type(STR)) { print_buffer_position(); error(1,0,"Error: variable used wrong context\n"); }; }
#line 3241 "src/selav1d/main.tab.c"
    break;

  case 62: /* var_psd: var  */
#line 1363 "src/selav1d/main.y"
             { if( true != (yyvsp[0].varval)->assert_type(PSD)) { print_buffer_position(); error(1,0,"Error: variable used wrong context\n"); }; }
#line 3247 "src/selav1d/main.tab.c"
    break;

  case 63: /* var_map: var  */
#line 1364 "src/selav1d/main.y"
             { if( true != (yyvsp[0].varval)->assert_type(MAP)) { print_buffer_position(); error(1,0,"Error: variable used wrong context\n"); }; }
#line 3253 "src/selav1d/main.tab.c"
    break;

  case 64: /* var: FLOAT  */
#line 1370 "src/selav1d/main.y"
           { (yyval.varval) = new var((yyvsp[0].fval)); }
#line 3259 "src/selav1d/main.tab.c"
    break;

  case 65: /* var: STRING  */
#line 1371 "src/selav1d/main.y"
                 { (yyval.varval) = new var((yyvsp[0].sval)); free((yyvsp[0].sval)); }
#line 3265 "src/selav1d/main.tab.c"
    break;

  case 66: /* var: BLOCK  */
#line 1372 "src/selav1d/main.y"
                 { (yyval.varval) = new var((yyvsp[0].sval)); free((yyvsp[0].sval)); }
#line 3271 "src/selav1d/main.tab.c"
    break;

  case 67: /* var: SYMBOL  */
#line 1373 "src/selav1d/main.y"
                 {
		if(ENV.count((yyvsp[0].sval))<=0) {
			print_buffer_position();
			error(1,0,"Error: Symbol '%s' not defined\n",(yyvsp[0].sval));
		}
		(yyval.varval) = ENV.at((yyvsp[0].sval))->ref();
		free((yyvsp[0].sval));
		}
#line 3284 "src/selav1d/main.tab.c"
    break;

  case 68: /* var: DEFINED '(' SYMBOL ')'  */
#line 1381 "src/selav1d/main.y"
                                 { (yyval.varval) = new var(ENV.count((yyvsp[-1].sval))>0 ? 1 : 0); free((yyvsp[-1].sval)); }
#line 3290 "src/selav1d/main.tab.c"
    break;

  case 74: /* var: INTEGRAL '(' var_psd ')'  */
#line 1387 "src/selav1d/main.y"
                                    { (yyval.varval) = new var((yyvsp[-1].varval)->psdval->integral()); (yyvsp[-1].varval)->unref(); }
#line 3296 "src/selav1d/main.tab.c"
    break;

  case 75: /* var: INTEGRAL '(' var_psd ',' var_str ')'  */
#line 1388 "src/selav1d/main.y"
                                                { (yyval.varval) = new var(integral_function__((yyvsp[-3].varval)->psdval,(yyvsp[-1].varval)->sval)); (yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref(); }
#line 3302 "src/selav1d/main.tab.c"
    break;

  case 76: /* var: CHARGE '(' var_psd ')'  */
#line 1389 "src/selav1d/main.y"
                                    { (yyval.varval) = new var((yyvsp[-1].varval)->psdval->weight);     (yyvsp[-1].varval)->unref(); }
#line 3308 "src/selav1d/main.tab.c"
    break;

  case 77: /* var: CENTROID '(' var_psd ')'  */
#line 1390 "src/selav1d/main.y"
                                    { (yyval.varval) = new var(0.0,2);  SLV::centroid((yyvsp[-1].varval)->psdval,(yyval.varval)->fval); (yyvsp[-1].varval)->unref(); }
#line 3314 "src/selav1d/main.tab.c"
    break;

  case 78: /* var: VARIANCE '(' var_psd ')'  */
#line 1391 "src/selav1d/main.y"
                                    { (yyval.varval) = new var(0.0,4);  SLV::variance((yyvsp[-1].varval)->psdval,(yyval.varval)->fval); (yyvsp[-1].varval)->unref(); }
#line 3320 "src/selav1d/main.tab.c"
    break;

  case 79: /* var: MAXIMUM '(' var_psd ')'  */
#line 1392 "src/selav1d/main.y"
                                    { (yyval.varval) = new var((yyvsp[-1].varval)->psdval->max()); (yyvsp[-1].varval)->unref(); }
#line 3326 "src/selav1d/main.tab.c"
    break;

  case 80: /* var: REFERENCE '(' var_psd ')'  */
#line 1393 "src/selav1d/main.y"
                                    { (yyval.varval) = new var(&(yyvsp[-1].varval)->psdval->refpoint[0],2); (yyvsp[-1].varval)->unref(); }
#line 3332 "src/selav1d/main.tab.c"
    break;

  case 81: /* var: LINSPACE '(' var_flt ',' var_flt ',' var_flt ')'  */
#line 1394 "src/selav1d/main.y"
                                                            {
		double a = *(yyvsp[-5].varval)->fval;
		double b = *(yyvsp[-3].varval)->fval;
		int n = *(yyvsp[-1].varval)->fval;
		(yyval.varval) = new var(0.0,n);
		for(int i=0; i<n; i++) {
			(yyval.varval)->fval[i] = a + (b-a)/(n-1) * i;
		}
		(yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref();
	}
#line 3347 "src/selav1d/main.tab.c"
    break;

  case 82: /* var: CHICANECOEF '(' var_flt ',' var_flt ',' var_flt ',' var_flt ')'  */
#line 1404 "src/selav1d/main.y"
                                                                          {
		int    n     = (yyvsp[-7].varval)->fval[0];
		double angle = (yyvsp[-5].varval)->fval[0];
		double lB    = (yyvsp[-3].varval)->fval[0];
		double lD    = (yyvsp[-1].varval)->fval[0];
		(yyval.varval) = new var(chicanecoef(n,angle,lB,lD));
		(yyvsp[-7].varval)->unref(); (yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref();
	}
#line 3360 "src/selav1d/main.tab.c"
    break;

  case 83: /* var: TRANSFER4D '(' var_flt ',' var_flt ',' var_flt ',' var_flt ',' var_flt ')'  */
#line 1412 "src/selav1d/main.y"
                                                                                     {
		double* R0    = (yyvsp[-9].varval)->fval;
		double l      = (yyvsp[-7].varval)->fval[0];
		double fangle = (yyvsp[-5].varval)->fval[0];
		double k0     = (yyvsp[-3].varval)->fval[0];
		double k1     = (yyvsp[-1].varval)->fval[0];
		(yyval.varval) = new var(0.0, 16);
		transfer4d((yyval.varval)->fval, R0, l, fangle, k0, k1);
		(yyvsp[-9].varval)->unref(); (yyvsp[-7].varval)->unref(); (yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref();
	}
#line 3375 "src/selav1d/main.tab.c"
    break;

  case 84: /* var: AVERAGE '(' var_flt ',' var_flt ',' var_flt ',' var_flt ')'  */
#line 1422 "src/selav1d/main.y"
                                                                      {
		double a   = (yyvsp[-7].varval)->fval[0];
		double b   = (yyvsp[-5].varval)->fval[0];
		double* xp = (yyvsp[-3].varval)->fval;
		double* yp = (yyvsp[-1].varval)->fval;
		(yyval.varval) = new var(average(a, b, xp, yp, (yyvsp[-3].varval)->size));
		(yyvsp[-7].varval)->unref(); (yyvsp[-5].varval)->unref(); (yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref();
	}
#line 3388 "src/selav1d/main.tab.c"
    break;

  case 85: /* var: STRCMP '(' var_str ',' var_str ')'  */
#line 1430 "src/selav1d/main.y"
                                             {
		(yyval.varval) = new var(1.0*strcmp((yyvsp[-3].varval)->sval, (yyvsp[-1].varval)->sval));
		(yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref();
	}
#line 3397 "src/selav1d/main.tab.c"
    break;

  case 86: /* string: FORMAT '(' var_str ',' vars_flt ')'  */
#line 1436 "src/selav1d/main.y"
                                             {
		char buf[512];
		double args[8];
		if((yyvsp[-1].fvals)->size()>8) {
			print_buffer_position();
			error(1,0,"Error: format: Too many arguments (>8).\n");
		}
		for(size_t i=0; i<(yyvsp[-1].fvals)->size(); i++) {
			args[i]=(*(yyvsp[-1].fvals))[i];
		}
		sprintf(buf,(yyvsp[-3].varval)->sval,
			args[0], args[1], args[2], args[3],
			args[4], args[5], args[6], args[7]
			);
		(yyval.varval) = new var(buf);
		(yyvsp[-3].varval)->unref(); delete (yyvsp[-1].fvals);
	}
#line 3419 "src/selav1d/main.tab.c"
    break;

  case 87: /* string: STRCAT '(' var_str ',' var_str ')'  */
#line 1453 "src/selav1d/main.y"
                                             {
		int len=strlen((yyvsp[-3].varval)->sval) + strlen((yyvsp[-1].varval)->sval) + 1;
		char buf[len];
		strcpy(buf,(yyvsp[-3].varval)->sval);
		strcat(buf,(yyvsp[-1].varval)->sval);
		(yyval.varval) = new var(buf);
		(yyvsp[-3].varval)->unref();
		(yyvsp[-1].varval)->unref();
	}
#line 3433 "src/selav1d/main.tab.c"
    break;

  case 88: /* string: GETCWD '(' ')'  */
#line 1462 "src/selav1d/main.y"
                         {
		char* dir =  get_current_dir_name();
		if(NULL==dir) { print_buffer_position(); perror("getcwd"); exit(1); };
		(yyval.varval) = new var(dir);
	}
#line 3443 "src/selav1d/main.tab.c"
    break;

  case 89: /* string: GETENV '(' var_str ')'  */
#line 1467 "src/selav1d/main.y"
                                 {
		const char* s = getenv((yyvsp[-1].varval)->sval);
		if(NULL==s) {
			print_buffer_position();
			fprintf(stderr,"getenv: Environment variable %s not defined\n",(yyvsp[-1].varval)->sval);
			exit(1);
		};
		(yyval.varval) = new var(s);
		(yyvsp[-1].varval)->unref();
	}
#line 3458 "src/selav1d/main.tab.c"
    break;

  case 90: /* string: STRTOD '(' var_str ')'  */
#line 1477 "src/selav1d/main.y"
                                 {
		errno = 0;
		double x = strtod((yyvsp[-1].varval)->sval,NULL);
		if(errno!=0) {
			print_buffer_position();
			fprintf(stderr,"strtod: %s conversion failed\n",(yyvsp[-1].varval)->sval);
			exit(1);
		}
		(yyval.varval) = new var(x);
		(yyvsp[-1].varval)->unref();
	}
#line 3474 "src/selav1d/main.tab.c"
    break;

  case 91: /* array: LBRACKET vars_flt RBRACKET  */
#line 1490 "src/selav1d/main.y"
                                  { (yyval.varval) = new var((yyvsp[-1].fvals)); delete (yyvsp[-1].fvals); }
#line 3480 "src/selav1d/main.tab.c"
    break;

  case 92: /* vars_flt: var_flt  */
#line 1492 "src/selav1d/main.y"
                  {
		(yyval.fvals) = new std::vector<double>;
		(yyval.fvals)->push_back((yyvsp[0].varval)->fval[0]);
		(yyvsp[0].varval)->unref();
	}
#line 3490 "src/selav1d/main.tab.c"
    break;

  case 93: /* vars_flt: vars_flt ',' var_flt  */
#line 1497 "src/selav1d/main.y"
                               {
		(yyvsp[-2].fvals)->push_back((yyvsp[0].varval)->fval[0]);
		(yyval.fvals) = (yyvsp[-2].fvals);
		(yyvsp[0].varval)->unref();
	}
#line 3500 "src/selav1d/main.tab.c"
    break;

  case 94: /* vars: var  */
#line 1505 "src/selav1d/main.y"
          { (yyval.varvals) = new varlist; (yyval.varvals)->push_back((yyvsp[0].varval)); }
#line 3506 "src/selav1d/main.tab.c"
    break;

  case 95: /* vars: vars ',' var  */
#line 1506 "src/selav1d/main.y"
                       { (yyvsp[-2].varvals)->push_back((yyvsp[0].varval)); (yyval.varvals) = (yyvsp[-2].varvals);}
#line 3512 "src/selav1d/main.tab.c"
    break;

  case 96: /* vars_map: var_map  */
#line 1509 "src/selav1d/main.y"
                  { (yyval.varvals) = new varlist; (yyval.varvals)->push_back((yyvsp[0].varval)); }
#line 3518 "src/selav1d/main.tab.c"
    break;

  case 97: /* vars_map: vars_map ',' var_map  */
#line 1510 "src/selav1d/main.y"
                               { (yyvsp[-2].varvals)->push_back((yyvsp[0].varval)); (yyval.varvals) = (yyvsp[-2].varvals);}
#line 3524 "src/selav1d/main.tab.c"
    break;

  case 98: /* exp: '(' var_flt ')'  */
#line 1514 "src/selav1d/main.y"
                    {(yyval.varval) = (yyvsp[-1].varval);}
#line 3530 "src/selav1d/main.tab.c"
    break;

  case 99: /* exp: var_flt PLUS var_flt  */
#line 1515 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(*(yyvsp[-2].varval) + *(yyvsp[0].varval));          (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3536 "src/selav1d/main.tab.c"
    break;

  case 100: /* exp: var_flt MINUS var_flt  */
#line 1516 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(*(yyvsp[-2].varval) - *(yyvsp[0].varval));          (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3542 "src/selav1d/main.tab.c"
    break;

  case 101: /* exp: MINUS var_flt  */
#line 1517 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(-1.0 * *(yyvsp[0].varval));         (yyvsp[0].varval)->unref(); }
#line 3548 "src/selav1d/main.tab.c"
    break;

  case 102: /* exp: PLUS var_flt  */
#line 1518 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(*(yyvsp[0].varval));                (yyvsp[0].varval)->unref(); }
#line 3554 "src/selav1d/main.tab.c"
    break;

  case 103: /* exp: var_flt TIMES var_flt  */
#line 1519 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(*(yyvsp[-2].varval) * *(yyvsp[0].varval));          (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3560 "src/selav1d/main.tab.c"
    break;

  case 104: /* exp: var_flt POW var_flt  */
#line 1520 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(pow((yyvsp[-2].varval)->fval[0],(yyvsp[0].varval)->fval[0]));
	                                                                 (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3567 "src/selav1d/main.tab.c"
    break;

  case 105: /* exp: var_flt DIVIDE var_flt  */
#line 1522 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(*(yyvsp[-2].varval) / *(yyvsp[0].varval));          (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3573 "src/selav1d/main.tab.c"
    break;

  case 106: /* exp: SIN '(' var_flt ')'  */
#line 1523 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(sin((yyvsp[-1].varval)->fval[0]));   (yyvsp[-1].varval)->unref(); }
#line 3579 "src/selav1d/main.tab.c"
    break;

  case 107: /* exp: COS '(' var_flt ')'  */
#line 1524 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(cos((yyvsp[-1].varval)->fval[0]));   (yyvsp[-1].varval)->unref(); }
#line 3585 "src/selav1d/main.tab.c"
    break;

  case 108: /* exp: ASIN '(' var_flt ')'  */
#line 1525 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(asin((yyvsp[-1].varval)->fval[0]));  (yyvsp[-1].varval)->unref(); }
#line 3591 "src/selav1d/main.tab.c"
    break;

  case 109: /* exp: ACOS '(' var_flt ')'  */
#line 1526 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(acos((yyvsp[-1].varval)->fval[0]));  (yyvsp[-1].varval)->unref(); }
#line 3597 "src/selav1d/main.tab.c"
    break;

  case 110: /* exp: TAN '(' var_flt ')'  */
#line 1527 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(tan((yyvsp[-1].varval)->fval[0]));   (yyvsp[-1].varval)->unref(); }
#line 3603 "src/selav1d/main.tab.c"
    break;

  case 111: /* exp: ATAN2 '(' var_flt ',' var_flt ')'  */
#line 1529 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(atan2((yyvsp[-3].varval)->fval[0],(yyvsp[-1].varval)->fval[0]));
				                                         (yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref();}
#line 3610 "src/selav1d/main.tab.c"
    break;

  case 112: /* exp: SQRT '(' var_flt ')'  */
#line 1531 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(sqrt((yyvsp[-1].varval)->fval[0]));  (yyvsp[-1].varval)->unref(); }
#line 3616 "src/selav1d/main.tab.c"
    break;

  case 113: /* exp: FLOOR '(' var_flt ')'  */
#line 1532 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(floor((yyvsp[-1].varval)->fval[0])); (yyvsp[-1].varval)->unref(); }
#line 3622 "src/selav1d/main.tab.c"
    break;

  case 114: /* exp: CEIL '(' var_flt ')'  */
#line 1533 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(ceil((yyvsp[-1].varval)->fval[0]));  (yyvsp[-1].varval)->unref(); }
#line 3628 "src/selav1d/main.tab.c"
    break;

  case 115: /* exp: ABS '(' var_flt ')'  */
#line 1534 "src/selav1d/main.y"
                                     { (yyval.varval) = new var(fabs((yyvsp[-1].varval)->fval[0]));  (yyvsp[-1].varval)->unref(); }
#line 3634 "src/selav1d/main.tab.c"
    break;

  case 116: /* exp: var_flt LBRACKET var_flt RBRACKET  */
#line 1535 "src/selav1d/main.y"
                                            { 
		size_t i = (yyvsp[-1].varval)->fval[0];
		if(i<0 || i>=(yyvsp[-3].varval)->size) { print_buffer_position(); error(1,0,"Error: Index out of range.\n"); }
		(yyval.varval) = new var((yyvsp[-3].varval)->fval[i]);
		(yyvsp[-3].varval)->unref(); (yyvsp[-1].varval)->unref();
		}
#line 3645 "src/selav1d/main.tab.c"
    break;

  case 117: /* exp: var_flt LT var_flt  */
#line 1543 "src/selav1d/main.y"
                                    { (yyval.varval) = new var((yyvsp[-2].varval)->fval[0] <  (yyvsp[0].varval)->fval[0] ?1:0); (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3651 "src/selav1d/main.tab.c"
    break;

  case 118: /* exp: var_flt LE var_flt  */
#line 1544 "src/selav1d/main.y"
                                    { (yyval.varval) = new var((yyvsp[-2].varval)->fval[0] <= (yyvsp[0].varval)->fval[0] ?1:0); (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3657 "src/selav1d/main.tab.c"
    break;

  case 119: /* exp: var_flt GE var_flt  */
#line 1545 "src/selav1d/main.y"
                                    { (yyval.varval) = new var((yyvsp[-2].varval)->fval[0] >= (yyvsp[0].varval)->fval[0] ?1:0); (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3663 "src/selav1d/main.tab.c"
    break;

  case 120: /* exp: var_flt EQ var_flt  */
#line 1546 "src/selav1d/main.y"
                                    { (yyval.varval) = new var((yyvsp[-2].varval)->fval[0] == (yyvsp[0].varval)->fval[0] ?1:0); (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3669 "src/selav1d/main.tab.c"
    break;

  case 121: /* exp: var_flt NE var_flt  */
#line 1547 "src/selav1d/main.y"
                                    { (yyval.varval) = new var((yyvsp[-2].varval)->fval[0] != (yyvsp[0].varval)->fval[0] ?1:0); (yyvsp[-2].varval)->unref(); (yyvsp[0].varval)->unref();}
#line 3675 "src/selav1d/main.tab.c"
    break;

  case 122: /* kwarg: SYMBOL '=' var  */
#line 1551 "src/selav1d/main.y"
                      { (yyval.varval) = (yyvsp[0].varval); (yyval.varval)->name = strdup((yyvsp[-2].sval)); free((yyvsp[-2].sval)); }
#line 3681 "src/selav1d/main.tab.c"
    break;

  case 123: /* kwargs: %empty  */
#line 1553 "src/selav1d/main.y"
        { (yyval.envval) = new environment; }
#line 3687 "src/selav1d/main.tab.c"
    break;

  case 124: /* kwargs: kwarg  */
#line 1554 "src/selav1d/main.y"
                {
		auto a = new environment;
		(*a)[(yyvsp[0].varval)->name] = (yyvsp[0].varval);
		(yyval.envval) = a;
	}
#line 3697 "src/selav1d/main.tab.c"
    break;

  case 125: /* kwargs: kwargs ',' kwarg  */
#line 1559 "src/selav1d/main.y"
                           {
		(*(yyvsp[-2].envval))[(yyvsp[0].varval)->name] = (yyvsp[0].varval);
	}
#line 3705 "src/selav1d/main.tab.c"
    break;


#line 3709 "src/selav1d/main.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1566 "src/selav1d/main.y"


int main(int argc, char* argv[]) {
	if(isatty(fileno(stdin))) fprintf(stdout,
		"selav1d  Copyright (C) 2020-2022  Philipp Amstutz (DESY)\n"
		"This program comes with ABSOLUTELY NO WARRANTY.\n"
		"This is free software, and you are welcome to redistribute it\n"
		"under certain conditions; see the file COPYING for details.\n"
		);
	fdstack_push(stdout);
	parse_file__("/dev/stdin");
	//yyparse();
	fdstack_pop();
	return 0;
}


extern int yylineno;
void yyerror(const char* s) {
	print_buffer_position();
	fprintf(stderr,"Error in line %d: %s\n",yylineno,s);
	exit(1);
}
