import random

op_dict = {
'+':(2,"%s+%s"),
'-':(2,"%s-%s"),
'u-':(1,"-%s"),
'u+':(1,"+%s"),
'*':(2,"%s*%s"),
'/':(2,"%s/%s"),
'SIN':(1,"sin(%s)"),
'COS':(1,"cos(%s)"),
'TAN':(1,"tan(%s)"),
'SQRT':(1,"sqrt(%s)"),
'P':(1,"(%s)"),
'T':(1,"%s"),
}
ops = []
ops += ['+']  * 4
ops += ['-']  * 4
ops += ['u-'] * 2
ops += ['u+'] * 2
ops += ['*']  * 2
ops += ['/']  * 2
ops += ['P']  * 8
ops += ['SQRT'] * 2
ops += ['SIN']  * 2
ops += ['COS']  * 2
ops += ['TAN']  * 2

def integer():
    r = random.randint(-512,512)
    i = random.choice([0,r,r,r])
    return str(i);

def real():
    fmt=random.choice(["%e","%f"])
    d = (random.random()-0.5)*100
    return fmt%d

def number():
    return random.choice([integer,real])()

def terminal():
    return random.choice([number])()

def node(d=3):
    op = random.choice(ops)
    order,fmd = op_dict[op]
    if op=='T':
        return (op,terminal())
    if d==0:
        return (op,[('T',terminal()) for i in range(order)])
    return (op,[node(d-1) for i in range(order)])


def node_string(n):
    op, args = n;
    order,fmt = op_dict[op]
    if op=='T':
        return fmt%str(args)
    return fmt % tuple([node_string(n) for n in args])


import sys
N=int(sys.argv[1])
O=int(sys.argv[2])
for i in range(N):
    n=node(O);
    print(node_string(n))
