#!/bin/bash


#depth ~= 7
run() {
../selav1d <<- EOF
bbox = [-7.0e-3, -10e4, 7.0e-3, 10e4];
psd = psd_ensemble("dist.ast",limits=bbox,depth=$1,nexp=$2,cutoff=6,nslices=64,type="astra",interpolation=2);
normalize(psd);
write_projection(psd,"p0.dat",2);
psd = propagate(psd,map_driftl(10e-16),box="KEEP",center="KEEP");
write_projection(psd,"p1.dat",2);
EOF
}

evalu() {
tmp=$(mktemp)
paste p0.dat p1.dat >$tmp
{ printf 'plot [-1e-3:1e-3] "%s" u 1:($4-$2)\n' $tmp ; }  | gnuplot --persist
}

run 5 2; evalu &
run 6 2; evalu &
run 7 2; evalu &
