#!/bin/bash


#depth ~= 7
run() {
../selav1d <<- EOF
bbox = [-7.0e-3, -10e4, 7.0e-3, 10e4];
psd = psd_ensemble("dist.ast",limits=bbox,depth=$1,nexp=$2,cutoff=6,nslices=64,type="astra",interpolation=2);
normalize(psd);
psd = propagate(psd,map_driftl(10e-9),box="KEEP",center="KEEP");
write_projection(psd,"p0.dat",0);
psd = psd_ensemble("dist.ast",limits=bbox,depth=$1,nexp=$2,cutoff=6,nslices=64,type="astra",interpolation=1);
normalize(psd);
psd = propagate(psd,map_driftl(10e-9),box="KEEP",center="KEEP");
write_projection(psd,"p1.dat",0);
EOF
}

show() {
python <<- EOF
import numpy as np
import matplotlib.pyplot as plt
q,p,psi0 = np.loadtxt("p0.dat").transpose()
q,p,psi1 = np.loadtxt("p1.dat").transpose()
n=int(np.sqrt(psi0.size))
psi0=psi0.reshape(n,n)
psi1=psi1.reshape(n,n)
plt.imshow(psi0-psi1)
plt.show()
EOF
}

run 6 3; show;

