#!/bin/bash


#depth ~= 7
run() {
../selav1d <<- EOF
psd = psd_gauss(interpolation=2,depth=4,nexp=3);
normalize(psd);
write_projection(psd,"p0.dat",0);
map = map_rotate(2*pi*0.2);
psd = propagate(psd,map,box="KEEP",center="KEEP");
write_projection(psd,"p1.dat",0);
show(psd);
who();
EOF
}

show() {
python <<- EOF
import numpy as np
import matplotlib.pyplot as plt
q,p,psi0 = np.loadtxt("p0.dat").transpose()
q,p,psi1 = np.loadtxt("p1.dat").transpose()
n=int(np.sqrt(psi0.size))
psi0=psi0.reshape(n,n)
psi1=psi1.reshape(n,n)
plt.imshow(psi0-psi1)
plt.show()
EOF
}

run; show;

